//@nt}֐Q
//		Copyright(c)2000 K.Kawahira

#include	<windows.h>

typedef struct hnode {
	unsigned int datl;
	unsigned int dat;
	struct hnode* child[2];
//	struct hnode* child1;
//	struct hnode* child2;
	char leaf;
	int cnt; //kp
} HNODE,*LPHNODE;

typedef struct hhead {
	char type[4];
	int size;
	int org_size;
	short head_size;
	short data_start;
	short tree_size;
	short tree_start;
} HHEAD;

////////////////////////////////////////////////////////////////
//	nt}ꂽf[^WJixj
//		|IWif[^Ή\ǂH

unsigned int inbit;
unsigned int indw;

//		Prbgǂݏo iłĂHj
inline int readbit(const UINT* buf){
	static int b;
	if (!(inbit++&31)) {
		b=buf[indw++];
	} else b>>=1;
	//inbit++;
	//inbit&=31;
	return b&1;
}
inline int readbit_(const UINT* buf){
	static int b;
	if (!inbit)
		b=buf[indw++];
	inbit=(inbit+1)&31;
	return (b>>inbit)&1;
}

int huffd (UCHAR* obuf,const UCHAR* ibuf,int size)
{
	if(!obuf)return 0; //s
	int i,j,k,l;
	HNODE branch[512];
	HNODE* tr[2][256];
	HNODE* mnode;
	HHEAD* head=(HHEAD*)ibuf;
	int p,tp;
	int bcnt=0;
	int st;
	//		
	//char d[16];
	//MessageBox(NULL,itoa(tp,d,10),"test",MB_OK);
	memset(branch,0,sizeof(HNODE)*512);
	memset(obuf,0,head->org_size);
	p=head->tree_size;
	st=head->tree_start;
	if(!size || size>head->org_size)size=head->org_size;
	// č\
	tp=sizeof(HHEAD)-1;
	tr[0][0]=&branch[0];
	l=1;
	bcnt=1;
	for(i=0;tp<head->data_start;i++){
		//if (tp>p)break;
		j=0;
		if (i>=st){
			while(ibuf[tp]!=ibuf[tp+1]||tp==sizeof(HHEAD)-1){
				tp++;
				tr[i&1][j]->leaf=ibuf[tp];
				j++;
				if(j>=l)break;
				//tp++;
			}
			tp++;
		}
		//if (i==p3) return -j;
		if(j>=l)break;
		k=l;
		l=0;
		for(l=0;j<k;j++){
			tr[i&1][j]->child[0]=&branch[bcnt];
			tr[(i+1)&1][l]=tr[i&1][j]->child[0];
			tr[i&1][j]->child[1]=&branch[bcnt+1];
			tr[(i+1)&1][l+1]=tr[i&1][j]->child[1];
			bcnt+=2;
			l+=2;
		}
	}
	mnode=&branch[0];
	inbit=0;
	indw=0;
	tp=0;
	ibuf+=head->data_start;
	for(i=0;tp<size;i++){
		mnode=mnode->child[readbit((UINT*)ibuf)];
		if (!mnode->child[0]){
			obuf[tp]=mnode->leaf;
			tp++;
			mnode=&branch[0];
		}
	}
	return head->org_size;
}



////////////////////////////////////////////////////////////////
//	nt}
//

unsigned int outbyte;
unsigned int outbit;

//		wrbg
int writebits(UCHAR* buf,unsigned int dat,unsigned int l){
	unsigned int i;
	if (l<=0 || l>=32)return 1;
	if(outbit){
		buf[outbyte]|=(dat&(1<<(8-outbit))-1)<<outbit;
		if (l < 8-outbit) {
			outbit+=l;
			return 0;
		}
		l-=8-outbit;
		dat>>=8-outbit;
		outbyte++;
		outbit=0;
	}
	buf+=outbyte;
	for(i=0;i<(l+7)>>3;i++){
		buf[i]=dat&0xff;
		dat>>=8;
	}
	outbit+=l;
	outbyte+=outbit>>3;
	outbit&=7;
	return 0;
}

int huffc(BYTE* outbuf,const BYTE* ibuf,int size)
{
	outbyte=0;
	outbit=0;
	int i,j,k,l;
	HNODE node[256];
	HNODE branch[512];
	HNODE* nodep[256];
	HNODE* tr[2][256];
	HNODE* root=NULL;
	HHEAD* head=(HHEAD*)outbuf;
	int p,tp;
	int st=-1;
	int bcnt=0;
	int min1,min2;
	//		
	memset(node,0,sizeof(HNODE)*256);
	memset(branch,0,sizeof(HNODE)*512);
	memset(&nodep,0,sizeof(HNODE*)*256);
	//		vƂ
	for(i=0;i<size;i++){
		node[ibuf[i]].cnt++;
	}
	for(i=0;i<256;i++){
		node[i].leaf=i;
		if (node[i].cnt)
			nodep[i]=&node[i];
	}
	for(j=0;j<255;j++){
		min1=-1;
		min2=-1;
		//		oŏƍŏQԂȂ̂TiOj
		for(i=0;i<256;i++){
			if(nodep[i]==NULL)continue;
			if(nodep[i]->cnt){
				if (min1<0)
					min1=i;
				else
					if (nodep[min1]->cnt > nodep[i]->cnt)min1=i;
			}
		}
		for(i=0;i<256;i++){
			if(i==min1 || nodep[i]==NULL)continue;
			if(nodep[i]->cnt){
				if (min2<0)
					min2=i;
				else
					if (nodep[min2]->cnt > nodep[i]->cnt)min2=i;
			}
		}
		if (min1<0 || min2<0) break;
		branch[bcnt].child[0]=nodep[min1];
		branch[bcnt].child[1]=nodep[min2];
		branch[bcnt].cnt=nodep[min1]->cnt+nodep[min2]->cnt;
		nodep[min1]=&branch[bcnt];
		nodep[min2]=NULL;
		root=nodep[min1];
		bcnt++;
	}
	if (!root)return -99;
	tr[0][0]=root;
	bcnt=1;
	p=sizeof(HHEAD);
	for(i=0;i<255;i++){
		k=0;
		for(j=0;j<bcnt;j++){
			if (tr[i&1][j]->child[0]){
				tr[(i+1)&1][k]=tr[i&1][j]->child[0];
				//tr[(i+1)&1][k]->dat=tr[i&1][j]->dat;
				//tr[(i+1)&1][k]->datl=tr[i&1][j]->datl+1; //32ȏɂȂȂH
				k++;
			}
			if (tr[i&1][j]->child[1]){
				tr[(i+1)&1][k]=tr[i&1][j]->child[1];
				//tr[(i+1)&1][k]->dat=tr[i&1][j]->dat+(1<<tr[i&1][j]->datl);
				//tr[(i+1)&1][k]->datl=tr[i&1][j]->datl+1;
				k++;
			}
			if (!tr[i&1][j]->child[0] && !tr[i&1][j]->child[1]){
				outbuf[p]=tr[i&1][j]->leaf;
				tp=tr[i&1][j]->leaf;
				p++;
				if (st<0) st=i;
				//return -i;
			}
		}
		//outbuf[p]=tr[i&1][bcnt-1]->leaf;
		if (st>=0) {
			outbuf[p]=tp;
			p++;
		}
		bcnt=k;
		if (!bcnt)break;
	}
	//outbuf[0]=p&0xff; //tree size
	//outbuf[1]=p>>8 & 0xff;
	//outbuf[2]=st; // tree start
	head->org_size=size;
	head->head_size=sizeof(HHEAD);
	head->tree_size=p-sizeof(HHEAD);
	head->tree_start=st;
	head->data_start=p;
	//return -p;
	// č\
	memset(branch,0,sizeof(HNODE)*512);
	tp=sizeof(HHEAD)-1;
	tr[0][0]=&branch[0];
	l=1;
	bcnt=1;
	for(i=0;tp<p;i++){
		//if (tp>p)break;
		j=0;
		if (i>=st){
			while(outbuf[tp]!=outbuf[tp+1]||tp==sizeof(HHEAD)-1){
				tp++;
				//tr[i&1][j]->leaf=outbuf[tp];
				node[outbuf[tp]].datl=tr[i&1][j]->datl;
				node[outbuf[tp]].dat=tr[i&1][j]->dat;
				j++;
				if(j>=l)break;
				//tp++;
			}
			tp++;
		}
		//if (i==p3) return -j;
		if(j>=l)break;
		k=l;
		l=0;
		for(l=0;j<k;j++){
			tr[i&1][j]->child[0]=&branch[bcnt];
			tr[(i+1)&1][l]=tr[i&1][j]->child[0];
			tr[i&1][j]->child[0]->datl=tr[i&1][j]->datl+1;
			tr[i&1][j]->child[0]->dat=tr[i&1][j]->dat;
			tr[i&1][j]->child[1]=&branch[bcnt+1];
			tr[(i+1)&1][l+1]=tr[i&1][j]->child[1];
			tr[i&1][j]->child[1]->datl=tr[i&1][j]->datl+1;
			tr[i&1][j]->child[1]->dat=tr[i&1][j]->dat+(1<<tr[i&1][j]->datl);
			bcnt+=2;
			//if (bcnt>512)return -i-10000;
			l+=2;
		}
	}
	//return -bcnt;
	//for(i=0;i<256;i++) ((int*)outbuf)[i]=node[buf[i]].dat; return -256*4; //ERR
	for(i=0;i<size;i++){
		//if (node[buf[i]].datl>31)
		//	return -((int)node[buf[i]].datl);
		if(writebits(outbuf+p,node[ibuf[i]].dat,node[ibuf[i]].datl)) return -node[ibuf[i]].leaf;
	}
	if (outbit)outbyte++;
	head->size=outbyte+p;
	return head->size;
}
