#include	<windows.h>
#include	<OLECTL.h>

#include <math.h>
#include "image.h"


////////////////////////////////////////////////////////////////////////////
//    CBitmap

CBitmap::~CBitmap()
{
	Delete();
}

CBitmap::CBitmap()
{
	flag=0;
}

int CBitmap::Create(int x,int y,int d)
{
	sx=x;
	sy=y;
	flag=1;
	if(d==0)d=24;
	if(d==32)flag|=256;
	depth=d;
	aline=(sx*(d>>3)+3)&~3;

	memset(&bmih,0,sizeof(bmih));
	bmih.biSize=sizeof(BITMAPINFOHEADER);
	bmih.biWidth=x;
	bmih.biHeight=y;
	bmih.biPlanes=1;
	bmih.biBitCount=d;
	bmih.biSizeImage=x*y*d>>3;

	HDC hdcWin=NULL;//GetDC(hMainWnd); /* EChEDC 擾 */
	hdc=CreateCompatibleDC(hdcWin); /* DC 쐬 */
	//ReleaseDC(hMainWnd,hdcWin);

	/* DIB ƃEChEDC DIBSection 쐬 */
	dib=CreateDIBSection(NULL,(BITMAPINFO*)&bmih,DIB_RGB_COLORS,(void**)&pBit,NULL,0);

	SelectObject(hdc,dib); /* DC DIBSection 蓖Ă */

	return 0;
}
void CBitmap::Delete(){
	if (flag) {
		DeleteDC(hdc);
		DeleteObject(dib);
	}
	flag=0;
}

void CBitmap::ClearWhite()
{
	memset(pBit,255,aline*sy);
}
void CBitmap::ClearBlack()
{
	memset(pBit,0,aline*sy);
}

// 90xƂ̉](摜obt@͍Ċm)
void CBitmap::Rotate(int deg)
{
	if (deg==0) return;
	CBitmap *bms=new CBitmap;
	int h,w;
	int x,y;
	w=sx;
	h=sy;

	if (deg&1) { // 2/PI*n
		bms->Create(h,w,0);
		unsigned char *img1=pBit;
		unsigned char *img2=bms->pBit;
		int bpl1=sx*3+3 & ~3;
		int bpl2=bms->sx*3+3 & ~3;
		if (deg<0) { // rotate left
			img2+=bms->sx*3-3;
			for(y=0;y<h;y++) {
				for(x=0;x<w;x++) {
					memcpy(img2+bpl2*x,img1+x*3,3);
				}
				img1+=bpl1;
				img2-=3;
			}
		} else { // rotate right
			for(y=0;y<h;y++) {
				for(x=0;x<w;x++) {
					memcpy(img2+bpl2*(w-x-1),img1+x*3,3);
				}
				img1+=bpl1;
				img2+=3;
			}
		}
	} else { // 2/PI*n:flip
		bms->Create(w,h,0);
		unsigned char *img1=pBit;
		unsigned char *img2=bms->pBit;
		int bpl1=sx*3+3 & ~3;
		int bpl2=bms->sx*3+3 & ~3;
		img2+=bpl2*h-3;
		for(y=0;y<h;y++) {
			for(x=0;x<w;x++) {
				memcpy(img2-x*3,img1+x*3,3);
			}
			img1+=bpl1;
			img2-=bpl2;
		}
	}

	Delete();
	*this = *bms;
}


// UpJ[fǂ
void CBitmap::ChangeTone(int hh,int ss,int vv)
{
	int x,y;
	int Ch,Cs,Cv,Cd;
	int r,g,b;
	int h,p,q,t;
	int m;
	unsigned char *img=pBit;
	for(y=0; y<sy; y++){
		for(x=0; x<sx*3; x+=3){
			if(img[x]<img[x+1]){
				Cv=img[x+1];
				Cd=img[x];
				m=1;
			} else {
				Cv=img[x];
				Cd=img[x+1];
				m=2;
			}
			if(Cv<img[x+2]){Cv=img[x+2];m=0;}
			if(Cd>img[x+2]) Cd=img[x+2];
			if(Cv>0){
				Cs=(Cv-Cd)*1024/Cv;
			} else {
				Cs=0;
			}
			if(Cs!=0){
				b=(Cv-img[x  ])*1024 / (Cv-Cd);
				g=(Cv-img[x+1])*1024 / (Cv-Cd);
				r=(Cv-img[x+2])*1024 / (Cv-Cd);
				if(m==0){
					Ch=(b-g);
				}else if(m==1){
					Ch=(r-b+2048);
				}else{
					Ch=(g-r+4096);
				}
			}else{
				Ch=0;
			}

			/// MAX
			//Ch 1024*6?
			//Cs 1024
			//Cv 255
			Ch+=hh;
			Cs=Cs*ss>>10;
			if(Cs>1024) Cs=1024;
			Cv=Cv*vv>>10;
			if(Cv>255) Cv=255;

			if(Cs==0){
				r=Cv;
				g=Cv;
				b=Cv;
			}else{
				//if(Ch<0) Ch+=1024*6;
				Ch=(Ch+1024*6)%(1024*6);
				h=Ch>>10;
				//if(h>5)h-=5;
				p=Cv*(1024-Cs) >>10;
				q=Cv*(1024*1024-Cs*(     Ch-h*1024)) >>20;
				t=Cv*(1024*1024-Cs*(1024-Ch+h*1024)) >>20;
				switch(h){
					case 0: r=Cv;g=t; b=p; break;
					case 1: r=q; g=Cv;b=p; break;
					case 2: r=p; g=Cv;b=t; break;
					case 3: r=p; g=q; b=Cv;break;
					case 4: r=t; g=p; b=Cv;break;
					case 5: r=Cv;g=p; b=q; break;
				}
			}
			img[x  ]=b;
			img[x+1]=g;
			img[x+2]=r;
		}
		img+= aline;
	}
}

void CBitmap::ChangeBrt(int bb,int cc,int vv)
{
	//RgXgE邳
	if(vv<=0)return;
	int x,y;
	unsigned char *img=pBit;
	int ttable[256];
	int i;
	for (i=0; i<256; i++) {
		ttable[i]=i+bb;
		//ttable[i]=(int)pow((double)ttable[i],1024.0/(double)vv);
		ttable[i]=(int)(pow((double)ttable[i]/255,1024.0/(double)vv)*255);
		ttable[i]=(ttable[i]-128)*cc/1024+128;
		if (ttable[i]>255) ttable[i]=255;
		if (ttable[i]<0) ttable[i]=0;
	}
	for(y=0; y<sy; y++){
		for(x=0; x<aline; x+=4){ // 32	rbgÂ
			img[x  ]=ttable[img[x  ]];
			img[x+1]=ttable[img[x+1]];
			img[x+2]=ttable[img[x+2]];
			img[x+3]=ttable[img[x+3]];
		}
		img+= aline;
	}
}



////////////////////////////////////////////////////////////////////////////
//    CGraph


#include "spi.h"
#define INI_FILENAME "kwViewer.ini"

#ifdef SPI
struct SPITABLE{
	char spi[512];
	char file[64];
};
#endif

//
//		nt} for KPC
int huffd(UCHAR* obuf,const UCHAR* ibuf,int size);
int huffc(UCHAR* obuf,const UCHAR* ibuf,int size);

void GetModuleDir(unsigned char* exedir){
	unsigned int i,p=0;
	unsigned int l=GetModuleFileName(NULL,(char*)exedir,320);
	for(i=0;i<l;i++){
		//QoCgpc
		if ((0x81<=exedir[i] && exedir[i]<=0x9f)
			|| (0xe0<=exedir[i] && exedir[i]<=0xec))
		{
			i++;
			continue;
		}
		if (exedir[i]=='\\') p=i;
	}
	if (p)exedir[p+(p==3)]=0;
}


// gǂ݂
long fLoad(char* buf,char* filename,int fsize)
{
//	int p=CPack::Load(buf,filename,fsize);
//	if (p) return p;
//	//@pbNt@C_Ȃʏt@C
	HANDLE hPF= CreateFile(filename, GENERIC_READ, 0, NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL, NULL);
	if(hPF == INVALID_HANDLE_VALUE)return 0;
	ULONG size;// = GetFileSize(hPF, NULL);
	// t@Cɓǂݍ
	ReadFile(hPF, buf, fsize, &size, NULL);
	CloseHandle(hPF);
	return size;
}

long fExist ( char* file)
{
//	int size=CPack::Exist(file);
//	if (size>=0) return size;
//	//@pbNt@C_Ȃʏt@C
	HANDLE hPF= CreateFile(file, GENERIC_READ, 0, NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL, NULL);
	if (hPF == INVALID_HANDLE_VALUE) return -1;
	int size=(int)GetFileSize(hPF, NULL);
	CloseHandle(hPF);
	return size;
}

bool CGrph::IsLoadable(char *lpPath)
{
	// t@C̑
	int size=fExist(lpPath);
	if(size<=0)return false;

	// gq
	int l = strlen(lpPath);
	if (l>=4) {
		if (stricmp(lpPath+l-4,".kpc")==0) return true;
		if (stricmp(lpPath+l-4,".bmp")==0) return true;
		if (stricmp(lpPath+l-4,".ico")==0) return true;
		if (stricmp(lpPath+l-4,".jpg")==0) return true;
		if (stricmp(lpPath+l-4,".gif")==0) return true;
	}

	char inifile[MAX_PATH];
	GetModuleDir((unsigned char*)inifile);
	if (strlen(inifile)>3) strcat(inifile,"\\");
	strcat(inifile,INI_FILENAME);

	char dat[4096];
	GetPrivateProfileString("spi",NULL,"?",dat,MAX_PATH,inifile);
	if (*dat=='?') return false;
	char *p = dat;
	while(*p){
		int ll = strlen(p);
		if (l>ll && stricmp(lpPath+l-ll,p)==0) return true;
		p+=ll;
	}
	return false;
}

bool CGrph::LoadPic(char *lpPath)
{
	int size=fExist(lpPath);
	if(size<=0)return false;
	HGLOBAL hGlobal = GlobalAlloc(GPTR, size);
	//	ǂݍ
	fLoad((char*)hGlobal,lpPath,size);
	int f = LoadKPC((LPBYTE)hGlobal);
#ifdef SPI
	if (!f) f = LoadBySPI((LPBYTE)hGlobal,size,lpPath);
#endif
	if (!f) f = LoadBMP((LPBYTE)hGlobal,size,lpPath);
	if (!f) f = LoadByOle(hGlobal,size);
	GlobalFree(hGlobal);
	return f!=0;
}

void undif(UCHAR* buf,int size){
	int i;
	UCHAR cc=0;
	for(i=0;i<size;i++){
		cc+=buf[i];
		buf[i]=cc;
	}
}

void unrle(UCHAR* obuf,UCHAR* ibuf,int size){
	//MessageBox(NULL,"OK start","Debug",MB_OK);
	int i=0,o=0,l=0;
	while(o<size){
		l=*(unsigned short*)(ibuf+i);
		i+=2;
		if(l&32768){
			l-=32768;
			memset(obuf+o,*(ibuf+i),l);
			i++;
			o+=l;
		}else{
			if(l==0)break;
			memcpy(obuf+o,ibuf+i,l);
			i+=l;
			o+=l;
		}
	}
	//MessageBox(NULL,"OK","Debug",MB_OK);
}

bool CGrph::LoadBMP(BYTE* buf,int size,char *szPath)
{
	if(memcmp(buf,"BM",2)) return false;

	// BITMAP쐬
	LPBITMAPFILEHEADER bh = (LPBITMAPFILEHEADER)buf;
	LPBITMAPINFOHEADER ih = (LPBITMAPINFOHEADER)(buf + sizeof(BITMAPFILEHEADER));
	LPBITMAPINFO bi = (LPBITMAPINFO)(buf + sizeof(BITMAPFILEHEADER));
	LPBYTE img = buf + bh->bfOffBits;
	bms->Create(ih->biWidth,ih->biHeight,0);
	HBITMAP hBmp = CreateDIBitmap(bms->hdc,ih,CBM_INIT,img,bi,DIB_RGB_COLORS);
	if (!hBmp) return false;
	HDC mDC= CreateCompatibleDC(bms->hdc);
	SelectObject(mDC,hBmp);
	BitBlt(bms->hdc,0,0,ih->biWidth,ih->biHeight,mDC,0,0,SRCCOPY);
	DeleteDC(mDC);
	DeleteObject(hBmp);
	return true;
}

#ifdef SPI

bool CGrph::LoadBySPI(BYTE* buf,int size,char *szPath)
{
	static SPITABLE list[256];
	int f;
	CSPI tmpspi;
	char inifile[MAX_PATH];
	char dat[4096];
	int spicnt=0;
	GetModuleDir((unsigned char*)inifile);
	if (strlen(inifile)>3) strcat(inifile,"\\");
	strcat(inifile,INI_FILENAME);
	GetPrivateProfileString("spi",NULL,"?",dat,MAX_PATH,inifile);
	if (*dat=='?') return false;
	char *p = dat;
	while(*p){
		strcpy(list[spicnt].file,p);
		GetPrivateProfileString("spi",p,"?",list[spicnt].spi,64,inifile);
		p+=strlen(p)+1;
		if (*list[spicnt].spi!='?') spicnt++;
	}

	int i;
	int l=strlen(szPath);
	for(i=0;i<spicnt;i++){
		if(stricmp(list[i].file,szPath+l-strlen(list[i].file))==0)break;
	}
	if(i>=spicnt)return false;
	if(!tmpspi.LoadSPI(list[i].spi)){
		MessageBox(NULL,"Error: Load",list[i].spi,MB_OK);
		return false;
	}
	if(!tmpspi.IsSupported(szPath,(DWORD)buf))
		return false;
	//PictureInfo info;
	HLOCAL phBInfo,phBm;
	//tmpspi.GetPictureInfo((LPSTR)hGlobal,size,0x1,&info);
	tmpspi.GetPicture((LPSTR)buf,size,0x1,&phBInfo,&phBm,NULL,0);
	LPBITMAPINFO pbi = (LPBITMAPINFO)LocalLock(phBInfo);
	LPBYTE pbuf = (LPBYTE)LocalLock(phBm);
	bms->Create(((LPBITMAPINFOHEADER)pbi)->biWidth,
				((LPBITMAPINFOHEADER)pbi)->biHeight,0);
	if(((LPBITMAPINFOHEADER)pbi)->biBitCount==24){
		memcpy(bms->pBit,pbuf,(bms->sx*3+3&~3)*bms->sy);
		f=1;
	}else{
		HDC hDC = hDC=CreateCompatibleDC(bms->hdc);
		HDC hDC1=GetDC(0);
		//BITMAPINFOHEADER ih;
		HBITMAP hBmp = CreateDIBitmap(hDC1,(LPBITMAPINFOHEADER)pbi,CBM_INIT,pbuf,pbi,DIB_RGB_COLORS);
		ReleaseDC(0,hDC1);
		SelectObject(hDC,hBmp);
		BitBlt(bms->hdc,0,0,bms->sx,bms->sy,hDC,0,0,SRCCOPY);
		DeleteDC(hDC);
		DeleteObject(hBmp);
		f=1;
	}
	LocalUnlock(phBInfo);
	LocalUnlock(phBm);
	LocalFree(phBInfo);
	LocalFree(phBm);

	return true;
}

#endif

	typedef struct KPCHEAD
	{
		char type[4];
		unsigned int file_size;
		short head_size;
		short flame;
		unsigned int sx;
		unsigned int sy;
		unsigned short mode;
		unsigned char planes;
		unsigned char flag; //?
	}KPCHEAD;
	typedef struct KPLIST
	{
		int size;
		//char dif;
		//char compf;
		unsigned dif:8;
		unsigned compf:1;
		unsigned rle:1;
		unsigned :0;
	}KPLIST;

bool CGrph::LoadKPC(BYTE* buf )
{
	int px=0,py=0;
	int x,y;
	KPCHEAD* head=(KPCHEAD*)buf;
	if(memcmp(head->type,"KPC",3)){
		return false;
	}
	KPLIST* plist=(KPLIST*)(buf+sizeof(KPCHEAD));
	int sx,sy,p;
	sx=head->sx;
	sy=head->sy;
	if(bms->flag==0)bms->Create(sx,sy,0);

	UCHAR * vram=bms->pBit; //BMSCR.pBit
	vram+=((bms->sx+3 & ~3)*py+px)*3;
	int i;

	// m
	BYTE* pls[8];
	for(i=0;i<head->planes;i++){
		pls[i]=(BYTE*)malloc(sx*sy);
	}
	p=head->head_size;
	//
	//v[ƂɓWJ
	for(i=0;i<head->planes;i++){
		if(plist[i].compf) huffd( pls[i],(UCHAR*)(buf+p), sx*sy );
		if(plist[i].rle){
			BYTE* pl=pls[i];
			pls[i]=(BYTE*)malloc(sx*sy);
			unrle(pls[i],pl,sx*sy);
			free(pl);
		}
		if(plist[i].dif) undif(pls[i],sx*sy);
		p+=plist[i].size;
	}
	//
	int rr,gg,bb,yy,yr,yb,aa;
	if(head->mode==0 && head->planes==3){
		//RGBJ[
		i=0;
		for(y=0;y<sy;y++){
			for(x=0;x<sx*3;x+=3){
				vram[x  ]=pls[0][i];
				vram[x+1]=pls[1][i];
				vram[x+2]=pls[2][i];
				i++;
			}
			vram+= bms->sx*3+3 & ~3;
		}
	}else if(head->mode==0 && head->planes==4){
		//RGBJ[+a
		i=0;
		for(y=0;y<sy;y++){
			for(x=0;x<sx*3;x+=3){
				aa=pls[4][i];
				if(aa>127)aa++; //̂ >>8
				vram[x  ]=(vram[x  ]*(aa) + pls[0][i]*(256-aa))>>8;;
				vram[x+1]=(vram[x+1]*(aa) + pls[0][i]*(256-aa))>>8;;
				vram[x+2]=(vram[x+2]*(aa) + pls[0][i]*(256-aa))>>8;;
				i++;
			}
			vram+= bms->sx*3+3 & ~3;
		}
	}else if(head->planes==1){
		//
		i=0;
		for(y=0;y<sy;y++){
			for(x=0;x<sx*3;x+=3){
				vram[x  ]=pls[0][i];
				vram[x+1]=pls[0][i];
				vram[x+2]=pls[0][i];
				i++;
			}
			vram+= bms->sx*3+3 & ~3;
		}
//		for(i=0;i<sx*sy;i++){
//			yy=pls[0][i];
//			bms->pBit[i*3]=yy;
//			bms->pBit[i*3+1]=yy;
//			bms->pBit[i*3+2]=yy;
//		}
	}else if(head->planes==2){
		//+
		i=0;
		for(y=0;y<sy;y++){
			for(x=0;x<sx*3;x+=3){
				aa=pls[1][i];
				if(aa>127)aa++; //̂ >>8
				yy=pls[0][i]*(256-aa);
				vram[x  ]=(vram[x  ]*aa+yy)>>8;
				vram[x+1]=(vram[x+1]*aa+yy)>>8;
				vram[x+2]=(vram[x+2]*aa+yy)>>8;
				i++;
			}
			vram+= bms->sx*3+3 & ~3;
		}
//		for(i=0;i<sx*sy;i++){
//			yy=pls[0][i];
//			aa=pls[1][i];
//			if(aa>127)aa++; //̂ >>8
//			bms->pBit[i*3  ]=(bms->pBit[i*3  ]*aa+yy*(256-aa))>>8;
//			bms->pBit[i*3+1]=(bms->pBit[i*3+1]*aa+yy*(256-aa))>>8;
//			bms->pBit[i*3+2]=(bms->pBit[i*3+2]*aa+yy*(256-aa))>>8;
//		}
	}else if(head->planes==3){
		//J[
		i=0;
		//for(i=0;i<sx*sy;i++){
		for(y=0;y<sy;y++){
			for(x=0;x<sx;x++){
			yy=pls[0][i];
			yr=pls[1][i];
			yb=pls[2][i];
			//rr=yr+yy-128;
			//bb=yb+yy-128;
			rr=yy+(yr<<5)/23-178;
			bb=yy+(yb*13>>3)-208;
			gg=((yy<<4)-rr*5-bb*3)>>3;
			if(rr<0)rr=0;else if(rr>255)rr=255;
			if(bb<0)bb=0;else if(bb>255)bb=255;
			if(gg<0)gg=0;else if(gg>255)gg=255;
			//bms->pBit[i*3]=bb;
			//bms->pBit[i*3+1]=gg;
			//bms->pBit[i*3+2]=rr;
				vram[x*3  ]=bb;
				vram[x*3+1]=gg;
				vram[x*3+2]=rr;
				i++;
			}
			vram+= bms->sx*3+3 & ~3;
		}
	}else if(head->planes>=4){
		//J[+
		i=0;
		for(y=0;y<sy;y++){
			for(x=0;x<sx;x++){
				yy=pls[0][i];
				yr=pls[1][i];
				yb=pls[2][i];
				aa=pls[3][i];
				rr=yy+(yr<<5)/23-178;
				bb=yy+(yb*13>>3)-208;
				gg=((yy<<4)-rr*5-bb*3)>>3;
				if(rr<0)rr=0;else if(rr>255)rr=255;
				if(bb<0)bb=0;else if(bb>255)bb=255;
				if(gg<0)gg=0;else if(gg>255)gg=255;
				if(aa){
					if(aa>127)aa++;
					*(vram+x*3  )=(*(vram+x*3  )*(aa)+bb*(256-aa))>>8;
					*(vram+x*3+1)=(*(vram+x*3+1)*(aa)+gg*(256-aa))>>8;
					*(vram+x*3+2)=(*(vram+x*3+2)*(aa)+rr*(256-aa))>>8;
				}else{
					vram[x*3  ]=bb;
					vram[x*3+1]=gg;
					vram[x*3+2]=rr;
				}
				//bms->pBit[i*3  ]=(bms->pBit[i*3  ]*aa+bb*(256-aa))>>8;
				//bms->pBit[i*3+1]=(bms->pBit[i*3+1]*aa+gg*(256-aa))>>8;
				//bms->pBit[i*3+2]=(bms->pBit[i*3+2]*aa+rr*(256-aa))>>8;
				i++;
			}
			vram+= bms->sx*3+3 & ~3;
		}
	}

	//
	for(i=0;i<head->planes;i++){
		free(pls[i]);
	}
	return true;
}

bool CGrph::LoadByOle(HGLOBAL hGlobal, int size){
	IStream *iStream;
	IPicture *iPicture;
	long lWidth,lHeight;
	//GIF͓ǂ܂Ȃ (2004.06.27@I)
	//if(!memcmp(hGlobal,"GIF",3)){
	//	MessageBox(NULL,"̂ߓǂݍ߂܂","G[",MB_OK);
	//	return false;
	//}
	if(CreateStreamOnHGlobal(hGlobal, TRUE, &iStream)!=S_OK){
		return false;
	}
	if(OleLoadPicture(iStream, size, TRUE, IID_IPicture, (LPVOID*)&iPicture)!=S_OK){
		return false;
	}
	iPicture->get_Width(&lWidth); //lpVtbl-> iPicture,
	iPicture->get_Height(&lHeight);

	if(bms->flag==0){
		HDC hdc=CreateDC("DISPLAY",NULL,NULL,NULL);
		int cxpi = GetDeviceCaps(hdc,LOGPIXELSX);
		int cypi = GetDeviceCaps(hdc,LOGPIXELSY);
		bms->Create(MulDiv(lWidth,cxpi,2540),
			MulDiv(lHeight,cypi,2540),0);
		DeleteDC(hdc);
	}
	int i=iPicture->Render(bms->hdc, 0, 0, bms->sx, bms->sy, 0, lHeight, lWidth, -lHeight, NULL);//` /lpVtbl->

	iPicture->Release();	//C[W
	return i==S_OK;
}


/////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
//	OXk
//
int runlength (BYTE* outbuf,BYTE* ibuf,int sz)
{
	int ps=0;
	int pm=2;
	int l=0;
	int o=-1;
	for(int p=0;p<sz;p++){
		if(o==ibuf[p] && l<32760){
			l++;
		}else{
			if(l>5){
				*(unsigned short*)(outbuf+ps)=pm-ps-l-2;
				*(unsigned short*)(outbuf+pm-l)=l+32768;
				ps=pm-l+3;
				pm=ps+2;
			}else if(pm-ps>32764){
				*(unsigned short*)(outbuf+ps)=pm-ps-2;
				ps=pm;
				pm=ps+2;
			}
			l=0;
		}
		outbuf[pm]=ibuf[p];
		pm++;
		o=ibuf[p];
	}
	if(pm-ps>2){
		if(l>5){
			*(unsigned short*)(outbuf+ps)=pm-ps-l-2;
			*(unsigned short*)(outbuf+pm-l)=l+32768;
			ps=pm-l+3;
			pm=ps+2;
		}else{
			*(unsigned short*)(outbuf+ps)=pm-ps-2;
			ps=pm;
			pm=ps+2;
		}
	}
	*(unsigned short*)(outbuf+pm)=0;
	return pm;
}

int diff(char* buf,int size)
{
	int i;
	char a,b=0;
	for(i=0;i<size;i++){
		a=buf[i];
		buf[i]-=b;
		b=a;
	}
	return 0;
}


int make_yrb(UCHAR* buf[], CBitmap *bms)
{
	UCHAR* vram=bms->pBit;
	int x,y;
	int rr,gg,bb;
	int yy,yr,yb;
	//int plsz=bms->sx*bms->sy;
	for(y=0;y<bms->sy;y++){
		for(x=0;x<bms->sx;x++){
			bb=vram[x*3  ];
			gg=vram[x*3+1];
			rr=vram[x*3+2];
			yy=(gg*8+rr*5+bb*3)>>4;
			yr=(rr-yy+178) *23>>5;
			yb=((bb-yy+208) <<3)/13;
			yb-=yb>255;
			//yr=yr+2&0xfc;
			//yb=yb+2&0xfc;
			buf[0][y*bms->sx+x]=yy;
			buf[1][y*bms->sx+x]=yr;
			buf[2][y*bms->sx+x]=yb;
		}
		vram+=(bms->sx*3+3)&~3;
	}
	return 0;
}


int make_rgb(UCHAR* buf[], CBitmap* bms)
{
	UCHAR* vram=bms->pBit;
	int x,y;
	for(y=0;y<bms->sy;y++){
		for(x=0;x<bms->sx;x++){
			buf[0][y*bms->sx+x]=vram[x*3  ];
			buf[1][y*bms->sx+x]=vram[x*3+1];
			buf[2][y*bms->sx+x]=vram[x*3+2];
		}
		vram+=(bms->sx*3+3)&~3;
	}
	return 0;
}

int make_alpha(UCHAR* buf, CBitmap* bms, int col)
{
	UCHAR* vram=bms->pBit;
	int x,y;
	int c=0;
	for(y=0;y<bms->sy;y++){
		for(x=0;x<bms->sx;x++){
			memcpy(&c,vram+x*3,3);
			buf[y*bms->sx+x]=(c==col)?255:0;
		}
		vram+=(bms->sx*3+3)&~3;
	}
	return 0;
}

int make_alpha2(UCHAR* buf, CBitmap* bms)
{
	UCHAR* vram=bms->pBit;
	int x,y;
	for(y=0;y<bms->sy;y++){
		for(x=0;x<bms->sx;x++){
			buf[y*bms->sx+x]=vram[x*3  ];
		}
		vram+=(bms->sx*3+3)&~3;
	}
	return 0;
}


bool CGrph::SaveBMP(char *szPath)
{
	if(bms->flag==0)
		return false;

	BITMAPFILEHEADER  bmFH;
    memset(&bmFH , 0 , sizeof(bmFH));
    bmFH.bfType = 0x4d42;
    bmFH.bfOffBits =sizeof(BITMAPINFOHEADER) + sizeof(BITMAPFILEHEADER);
    bmFH.bfSize = bms->bmih.biSizeImage + bmFH.bfOffBits;

	HANDLE hPF= CreateFile(szPath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL, NULL);
	if(hPF == INVALID_HANDLE_VALUE)return false;
	ULONG size;

    WriteFile(hPF, &bmFH, sizeof(bmFH), &size, NULL);
    //BITMAPINFOHEADER\̈ȉ
    WriteFile(hPF, &bms->bmih, (DWORD)(sizeof(BITMAPINFOHEADER)), &size, NULL);
    WriteFile(hPF, bms->pBit, (DWORD)(bms->bmih.biSizeImage), &size, NULL);

	CloseHandle(hPF);
	return true;
}


bool CGrph::SaveKPC(char *szPath, int mode, UINT flag, UINT col, char *lpAFile)
{
	if(bms->flag==0)
		return false;

	int i;
	int pls=3;
	if(mode==2){
		mode=1;
		pls=1;
	}
	int fsize=sizeof(KPCHEAD)+pls*sizeof(KPLIST);
	KPCHEAD head;
	KPLIST plist[4];

	memcpy(head.type,"KPC0",4);
	memset(plist,0,sizeof(KPLIST)*4);
	BYTE* buf[4];
	//m
	for(i=0;i<4;i++){
		buf[i]=(BYTE*)malloc(bms->sx*bms->sy);
	}
	if(mode==0){
		make_rgb(buf,bms);
	}else if(mode==1){
		make_yrb(buf,bms);
	}else{
		//palette
		MessageBox(NULL,"ΉłD","Error!02",MB_OK);
		return false;
	}
	if(flag>>8 == 1){
		make_alpha(buf[pls],bms,col);
		pls++;
	}
	if(flag>>8 == 2 && lpAFile && lpAFile[0]){
		CGrph CG2;
		CG2.bms=new CBitmap;
		CG2.LoadPic(lpAFile);
		make_alpha2(buf[pls],CG2.bms);
		delete CG2.bms;
		pls++;
	}


	//v[ƂɈk
	int s,sz;
	for(i=0;i<pls;i++){
		sz=bms->sx*bms->sy;
		if(flag&1){
			diff((char*)buf[i],sz);
			plist[i].dif=1;
		}
		if(flag&2){
			BYTE* p=(BYTE*)malloc(sz+1024);
			s=runlength(p,buf[i],sz);
			if(s<sz){
				memcpy(buf[i],p,s);
				sz=s;
				plist[i].rle=1;
			}
			free(p);
		}
		if(flag&4){
			BYTE* p=(BYTE*)malloc(sz+1024);
			s=huffc(p,buf[i],sz);
			if(s<sz){
				memcpy(buf[i],p,s);
				sz=s;
				plist[i].compf=1;
			}
			free(p);
		}
		plist[i].size=sz;
		fsize+=sz;
	}

	head.file_size=fsize;
	head.head_size=sizeof(KPCHEAD)+sizeof(KPLIST)*pls;
	head.sx=bms->sx;
	head.sy=bms->sy;
	head.planes=pls;
	head.mode=mode&0xff;

	HANDLE hPF= CreateFile(szPath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL, NULL);
	if(hPF == INVALID_HANDLE_VALUE)return false;
	ULONG size;

    WriteFile(hPF, &head, sizeof(KPCHEAD), &size, NULL);
    WriteFile(hPF, plist, sizeof(KPLIST)*pls, &size, NULL);
	for(i=0;i<pls;i++){
	    WriteFile(hPF, buf[i], plist[i].size, &size, NULL);
		free(buf[i]);
	}

	CloseHandle(hPF);

	//obt@
	for(i=0;i<4;i++){
		free(buf[i]);
	}
	return true;
}
