/////////////////////////////////////////////////////////////////////////////
//		kwViewer	Ver.0.6
//
//				Copyright(c) 2002-2006 K.Kawahira
/////////////////////////////////////////////////////////////////////////////

//#define WINVER 0x0500
#include <windows.h>
#include <commctrl.h>
#include "resource.h"
#include "image.h"

// STL
#include<string>
#include<vector>
using namespace std;


#ifndef SPI_GETFOREGROUNDLOCKTIMEOUT
#define SPI_GETFOREGROUNDLOCKTIMEOUT 0x2000
#define SPI_SETFOREGROUNDLOCKTIMEOUT 0x2001
#endif

#ifndef WM_MOUSEWHEEL
#define WM_MOUSEWHEEL 0x020A
#define WHEEL_DELTA 120
#endif

#define APP_NAME "kwViewer"
#define APP_VER "kwViewer Ver.0.70"
#define INI_FILENAME "kwViewer.ini"

#if MAX_PATH<512
#undef MAX_PATH
#define MAX_PATH 512
#endif

//#pragma link "comctl32.lib" // BCC
#pragma comment(lib, "comctl32.lib") // VC++

#pragma warning(disable : 4996)

/////////////////////////////////////////////////////////////////////////////


//bool twain_init(HWND hWnd);
bool twain_get(HWND hWnd,CBitmap *bms,int flag, UINT lprm);
int twain_msg(LPMSG msg);
bool twain_select(HWND hWnd,char *name);
bool twain_free();
#define TWAIN_SUCCESS 0x7001

LRESULT CALLBACK WindowProc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK KPCDlgProc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK ReSizeDlgProc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK ChgHSVDlgProc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK ChgBCGDlgProc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK ConfigDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);

HINSTANCE hInst;
//CGrph CG; // \Ă摜

POINT pos;
POINT wsize;

char CurrentFile[MAX_PATH]; // ݂̃t@C

// DDE
HCONV hConv;
DWORD ddeInst;
HSZ hszService;
HSZ hszTopic;

void GetIniFile(unsigned char* ini){
	unsigned int i,p=0;
	unsigned int l=GetModuleFileName(NULL,(char*)ini,MAX_PATH);
	for(i=0;i<l;i++){
		//QoCgpc
		if ((0x81<=ini[i] && ini[i]<=0x9f)
			|| (0xe0<=ini[i] && ini[i]<=0xec))
		{
			i++;
			continue;
		}
		if (ini[i]=='\\') p=i;
	}
	if (p)ini[p+1]=0;
	strcat((char*)ini,INI_FILENAME);
}


///////////////////////////////////////////////////////////////////////////

class ImageWindow
{
	HWND hWnd;
	SCROLLINFO scx;
	SCROLLINFO scy;
	bool fitwindow;
	void UpdateScroll();
	void Scroll(int x,int y);
public:
	CBitmap *dib;
	int sx,sy;
	ImageWindow(HWND hParentWnd);
	ImageWindow(){dib=NULL;}
	~ImageWindow(){if (dib) delete dib;}
	void setSize(int w,int h);
	void fitToWindow(bool flag);
	bool isFitToWindow() {return fitwindow;}
	static LRESULT CALLBACK WindowProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);
};

ImageWindow::ImageWindow(HWND hParentWnd)
{
	WNDCLASSEX wc;
	HINSTANCE hInst = GetModuleHandle(NULL);

	if (!GetClassInfoEx(hInst,"kwImage",&wc)) {
		// EChENXo^
		wc.cbSize		= sizeof(wc);
		wc.lpfnWndProc	= WindowProc;
		wc.style		= CS_HREDRAW | CS_VREDRAW;
		wc.cbClsExtra	= 0;
		wc.cbWndExtra	= 0;
		wc.hInstance	= hInst;
		wc.hIcon		= LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON1));
		wc.hCursor		= LoadCursor(NULL,IDC_ARROW);
		wc.hbrBackground= (HBRUSH)(COLOR_WINDOW+1);
		wc.hIconSm		= NULL;
		wc.lpszMenuName	=MAKEINTRESOURCE(IDR_MENU1);
		wc.lpszClassName = "kwImage";
		if (!RegisterClassEx(&wc)) return;
	}
	hWnd = CreateWindow("kwImage","",
						WS_CHILD , //WS_OVERLAPPEDWINDOW,
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						1,1,
						hParentWnd,
						(HMENU)NULL,
						hInst, 0);

	SetWindowLongPtr(hWnd,GWLP_USERDATA,(LONG_PTR)this);
	ShowWindow(hWnd,SW_SHOW);
	dib = new CBitmap;
	dib->Create(320,240,24);
	dib->ClearWhite();
}

void ImageWindow::UpdateScroll()
{
	RECT rt;
	int x,y;
	x=dib->sx;
	y=dib->sy;
	// NCAg̈̃TCY߂
	GetClientRect(hWnd, &rt);
	int ws = GetWindowLong(hWnd,GWL_STYLE);
	if(ws & WS_HSCROLL)
		rt.bottom += GetSystemMetrics(SM_CYHSCROLL);
	if(ws & WS_VSCROLL)
		rt.right  += GetSystemMetrics(SM_CXVSCROLL);

	// XN[o[vZ
	if (x > rt.right) {
		rt.bottom -= GetSystemMetrics(SM_CYHSCROLL);
		if (y > rt.bottom)
			rt.right  -= GetSystemMetrics(SM_CXVSCROLL);
	} else if (y > rt.bottom) {
		rt.right  -= GetSystemMetrics(SM_CXVSCROLL);
		if (x > rt.right)
			rt.bottom  -= GetSystemMetrics(SM_CYHSCROLL);
	}

	if (pos.x >= x-rt.right ) pos.x = x-rt.right -1;
	if (pos.y >= y-rt.bottom) pos.y = y-rt.bottom-1;
	if (pos.x < 0) pos.x = 0;
	if (pos.y < 0) pos.y = 0;

	scx.cbSize = sizeof(SCROLLINFO);
	scx.fMask = SIF_POS | SIF_RANGE | SIF_PAGE;
	scx.nMin = 0;
	scx.nMax = x-1;
	scx.nPage =  rt.right;
	scx.nPos = pos.x;
	scy.cbSize = sizeof(SCROLLINFO);
	scy.fMask = SIF_POS | SIF_RANGE | SIF_PAGE;
	scy.nMin = 0;
	scy.nMax = y-1;
	scy.nPage =  rt.bottom;
	scy.nPos = pos.y;


	if (fitwindow) {
		scx.nMax = 0;
		scy.nMax = 0;
	}

	SetScrollInfo(hWnd, SB_HORZ, &scx, TRUE);
	SetScrollInfo(hWnd, SB_VERT, &scy, TRUE);

}

void ImageWindow::setSize(int w,int h)
{
	SetWindowPos(hWnd,NULL,0,0,w,h,SWP_NOZORDER|SWP_NOMOVE);
}

void ImageWindow::fitToWindow(bool flag)
{
	fitwindow = flag;
	UpdateScroll();
}

void ImageWindow::Scroll(int x,int y){
	if (fitwindow)
		return;

	x=max(-scx.nPos,x);
	x=min(dib->sx-(int)scx.nPage-pos.x,x);
	if(dib->sx<(int)scx.nPage) x=0;
	y=max(-scy.nPos,y);
	y=min(dib->sy-(int)scy.nPage-pos.y,y);
	if(dib->sy<(int)scy.nPage) y=0;
	if (y!=0 || x!=0) {
		pos.x+=x;
		scx.nPos = pos.x;
		SetScrollInfo(hWnd, SB_HORZ, &scx, TRUE);
		pos.y+=y;
		scy.nPos = pos.y;
		SetScrollInfo(hWnd, SB_VERT, &scy, TRUE);
		ScrollWindow(hWnd, -x, -y , NULL, NULL);
		UpdateWindow(hWnd);
	}
}

LRESULT CALLBACK ImageWindow::WindowProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	ImageWindow *_this = (ImageWindow*)GetWindowLongPtr(hWnd,GWLP_USERDATA);
	if (!_this) return DefWindowProc(hWnd,message,wParam,lParam);

	CBitmap *dib = _this->dib;

	static PAINTSTRUCT ps;
	static POINT pt;


	switch(message)
	{
		case WM_CREATE:
			break;
		case WM_PAINT:
			{
				HDC hDC = BeginPaint (hWnd, &ps);
				RECT rt;
				int x=0,y=0;
				GetClientRect( hWnd, &rt );
				FillRect(hDC,&rt,(HBRUSH)(COLOR_WINDOW + 1));

				if (_this->fitwindow) { // EChEɍ킹
					int w,h;
					w = dib->sx;
					h = dib->sy;
					if (h > rt.bottom) {
						w = w*rt.bottom/h;
						h = rt.bottom;
					}
					if (w > rt.right) {
						h = h*rt.right/w;
						w = rt.right;
					}
					if (rt.right>w)
						x=(rt.right-w)/2;
					if (rt.bottom>h)
						y=(rt.bottom-h)/2;
					SetStretchBltMode(hDC,STRETCH_HALFTONE);
					StretchBlt(hDC,x,y,w,h, dib->hdc,0,0,dib->sx,dib->sy,SRCCOPY);
				} else {
					if(rt.right>dib->sx){
						x=(rt.right-dib->sx)>>1;
					}
					if(rt.bottom>dib->sy){
						y=(rt.bottom-dib->sy)>>1;
					}
					BitBlt(hDC,x,y,rt.right,rt.bottom,dib->hdc,pos.x,pos.y,SRCCOPY);
				}
				EndPaint( hWnd, &ps );
			}
			break;
		case WM_SIZE:
				_this->UpdateScroll();
				break;
		case WM_MOUSEWHEEL:
			{
				int x=0,y=0;
				if(LOWORD(wParam)==MK_SHIFT){
					//_this->Scroll(x,y);
					x=-(SHORT)HIWORD(wParam)*16/WHEEL_DELTA;
				}else{
					y=-(SHORT)HIWORD(wParam)*16/WHEEL_DELTA;
				}
				_this->Scroll(x,y);
			}
			break;
		case WM_HSCROLL:
			{
			int x;
			switch (LOWORD(wParam)) {
			case SB_LINEUP:
				x = -10;
				break;
			case SB_LINEDOWN:
				x = 10;
				break;
			case SB_PAGEUP:
				x = -80;
				break;
			case SB_PAGEDOWN:
				x = 80;
				break;
			case SB_THUMBTRACK:
				x = HIWORD(wParam) - pos.x;
				break;
			default:
				x = 0;
				break;
			}
			_this->Scroll(x,0);
			}
            break;
		case WM_VSCROLL:
			{
			int y;
			if(message==WM_MOUSEWHEEL)
				y=-(SHORT)HIWORD(wParam)*16/WHEEL_DELTA;
			else
			switch (LOWORD(wParam)) {
			case SB_LINEUP:
				y = -10;
				break;
			case SB_LINEDOWN:
				y = 10;
				break;
			case SB_PAGEUP:
				y = -80;
				break;
			case SB_PAGEDOWN:
				y = 80;
				break;
			case SB_THUMBTRACK:
				y = HIWORD(wParam) - pos.y;
				break;
			default:
				y = 0;
				break;
			}
			_this->Scroll(0,y);
            break;
			}
		case WM_LBUTTONDOWN:
			pt.x=LOWORD(lParam);
			pt.y=HIWORD(lParam);
			SetFocus(hWnd);
			SetCapture(hWnd);
			break;
		case WM_LBUTTONUP:
			ReleaseCapture();
			break;
		case WM_MOUSEMOVE:
			if(wParam & MK_LBUTTON){
				_this->Scroll(pt.x-(signed short)LOWORD(lParam), pt.y-(signed short)HIWORD(lParam));
				pt.x=(signed short)LOWORD(lParam);
				pt.y=(signed short)HIWORD(lParam);
			}
			break;
		case WM_CLOSE:
			break;
		case WM_DESTROY:
			return  0;
	}
	return  DefWindowProc(hWnd,message,wParam,lParam);
}



ImageWindow *imgwnd;

////////////////////////////////////////////////////////////////////
class Window{
	HWND hWnd;
public:
	HWND hStatus;
	bool fStatus;
	void SetHandle(HWND hw){hWnd=hw;}
	bool Window::WinResize();
	void setStatus(bool flag);
	void updateStatus();
	Window(){hStatus=NULL;}
} MainWindow;

bool Window::WinResize()
{
	RECT rt;
	pos.x=0;
	pos.y=0;

	WINDOWPLACEMENT wp;
	wp.length=sizeof(WINDOWPLACEMENT);
	GetWindowPlacement(hWnd,&wp);

	// EChȆ傫߂
	rt.left=0;
	rt.top=0;
	rt.right=imgwnd->dib->sx; //CG.bms->sx;
	rt.bottom=imgwnd->dib->sy; //CG.bms->sy;
	AdjustWindowRect(&rt, WS_OVERLAPPEDWINDOW, TRUE);
	wsize.x=rt.right-rt.left;
	wsize.y=rt.bottom-rt.top;

	if(wp.showCmd == SW_SHOWMAXIMIZED){
		RedrawWindow(hWnd,NULL,NULL,RDW_INVALIDATE|RDW_UPDATENOW|RDW_ALLCHILDREN);
		return true;
	}


	int x,y;
	x=min(800,wsize.x);
	y=min(600,wsize.y);
	SetWindowPos(hWnd,NULL,0,0,x,y,SWP_NOZORDER|SWP_NOMOVE);

	// xNCAg̈킹
	GetClientRect(hWnd,&rt);
	if(rt.bottom<imgwnd->dib->sy)
		wsize.y+=imgwnd->dib->sy-rt.bottom;
	int t=min(600,wsize.y);
	if (t!=y)
		SetWindowPos(hWnd,NULL,0,0,x,t,SWP_NOZORDER|SWP_NOMOVE);

//	SetScroll();
	RedrawWindow(hWnd,NULL,NULL,RDW_INVALIDATE|RDW_UPDATENOW|RDW_ALLCHILDREN);
	return true;
}

void Window::updateStatus()
{
	int a[]={100,300,500};
	char s[64];
	wsprintf(s,"size: %d x %d",imgwnd->dib->sx,imgwnd->dib->sy);
	SendMessage(hStatus, SB_SETPARTS, 3, (LPARAM)a);
	SendMessage(hStatus, SB_SETTEXT, 0 , (LPARAM)"Standby ready");
	SendMessage(hStatus, SB_SETTEXT, 1 , (LPARAM)s);
}

void Window::setStatus(bool flag)
{
	if (flag) {
		if (hStatus) {
			ShowWindow(hStatus,SW_SHOW);
		} else {
			// ŏ͍
			InitCommonControls();
			hStatus = CreateStatusWindow( WS_CHILD | WS_VISIBLE | CCS_BOTTOM | SBARS_SIZEGRIP, 
				NULL, hWnd,100);
			ShowWindow(hStatus,SW_SHOW);
		}
	}else{
		if (hStatus)
			ShowWindow(hStatus,SW_HIDE);
	}
	fStatus = flag;
	updateStatus();
	RedrawWindow(hWnd,NULL,NULL,RDW_INVALIDATE|RDW_UPDATENOW|RDW_ALLCHILDREN);
}


void SetAbsForegroundWindow(HWND hWnd)
{
	int nTargetID, nForegroundID;
	DWORD sp_time;
	nForegroundID = GetWindowThreadProcessId(GetForegroundWindow(), NULL);
	nTargetID = GetWindowThreadProcessId(hWnd, NULL );
	AttachThreadInput(nTargetID, nForegroundID, TRUE );  // Xbhѕt
	SystemParametersInfo( SPI_GETFOREGROUNDLOCKTIMEOUT,0,&sp_time,0);
	SystemParametersInfo( SPI_SETFOREGROUNDLOCKTIMEOUT,0,(LPVOID)0,0);
	SetForegroundWindow(hWnd);
	SystemParametersInfo( SPI_SETFOREGROUNDLOCKTIMEOUT,0,(LPVOID)sp_time,0);
	AttachThreadInput(nTargetID, nForegroundID, FALSE );  // Xbh؂藣
}


bool Load(char* lpPath,HWND hWnd){
	bool f=false;
	if(memcmp(lpPath,"CMD:TWAIN",9)==0){
		SetWindowText(hWnd,"TWAIN@ " APP_NAME);
		if (lpPath[9]=='\\') {
			// fBoCX𓾂(ƃX}[gȕ@͂)
			char name[MAX_PATH];
			char event[MAX_PATH]="";
			HKEY hKey,hKey2;
			char key[MAX_PATH];
			ULONG r,len=sizeof(name);
			r=strchr(lpPath+10,' ')-(lpPath+10);
			if (r<MAX_PATH) { // found
				// Cxg
				lpPath[10+r]='\0';
				strcpy(event,lpPath+10+r+1);
			}
			strcpy(key,"SYSTEM\\CurrentControlSet\\Control\\Class\\");
			strcat(key,lpPath+10);
			// strcat(key,\\DeviceData\\TwainDS) ?
			RegCreateKeyEx(HKEY_LOCAL_MACHINE,key,0,"",
				REG_OPTION_NON_VOLATILE,KEY_READ,NULL,&hKey,&r);
			if (RegQueryValueEx(hKey,"DriverDesc",NULL, NULL,(unsigned char*)name,&len)==ERROR_SUCCESS) {
				// TWAINfBoCXI
				twain_select(hWnd,name);
				char wname[MAX_PATH+64];
				wsprintf(wname,"TWAIN@:%s " APP_NAME,name);
				SetWindowText(hWnd,wname);
			} else {
				twain_select(hWnd,NULL);
			}
			RegCloseKey(hKey);

			if (event[0] ) {
				// CxgT
				strcat(key,"\\Events");
				RegCreateKeyEx(HKEY_LOCAL_MACHINE,key,0,"",
					REG_OPTION_NON_VOLATILE,KEY_ENUMERATE_SUB_KEYS,NULL,&hKey,&r);
				int i;
				for (i=0;;i++){
					len=sizeof(name);
					if(RegEnumKeyEx(hKey,i,name,&len,NULL,NULL,NULL,NULL)
						!=ERROR_SUCCESS) break;
					RegCreateKeyEx(hKey,name,0,"",
						REG_OPTION_NON_VOLATILE,KEY_READ,NULL,&hKey2,&r);
					len=sizeof(name);
					if (RegQueryValueEx(hKey2,"GUID",NULL, NULL,(unsigned char*)name,&len)
						==ERROR_SUCCESS) {
						if (strcmpi(name,event)==0){
							len=sizeof(event);
							if (RegQueryValueEx(hKey2,"",NULL, NULL,(unsigned char*)event,&len)
								==ERROR_SUCCESS) {
							}
							break;
						}
					}
					RegCloseKey(hKey2);
				}
				RegCloseKey(hKey);

				char inifile[MAX_PATH];
				GetIniFile((unsigned char*)inifile);
				int cmd=GetPrivateProfileInt("EVENT",event,-1,inifile);
				//GetPrivateProfileString("EVENT",event,"?",cmd,MAX_PATH,inifile);
				switch(cmd){
				case 0:
					break;
				case 1:
					twain_get(hWnd,imgwnd->dib,1,0);
					break;
				case 2:
					twain_get(hWnd,imgwnd->dib,0,0);
					break;
				case 3:
					twain_get(hWnd,imgwnd->dib,0,3);
					break;
				case 4:
					twain_get(hWnd,imgwnd->dib,0,4);
					break;
				default:
					WritePrivateProfileString("EVENT",event,"0",inifile);
					MessageBox(hWnd,event,"Cxgo^܂",MB_OK);
				}
			}
		}else{
			twain_get(hWnd,imgwnd->dib,0,0);
		}
		strcpy(CurrentFile,"");
		f=true;
	}else{
		//HANDLE hFile= CreateFile(lpPath, GENERIC_READ, 0, NULL, OPEN_EXISTING,
		// GetFileSize(hFile,NULL);
		//CloseFile(hFile);

		imgwnd->dib->Delete();
		CGrph CG2;
		CG2.bms = imgwnd->dib;
		f=CG2.LoadPic(lpPath);
		if (f) MainWindow.WinResize();

		strcpy(CurrentFile,lpPath);
		char s[256];
		int i=0,j=0;
		while(lpPath[++i]){
			if(lpPath[i]=='\\')
				j=i+1;
		}
		strcpy(s,lpPath+j);
		strcat(s," - " APP_NAME);
		SetWindowText(hWnd,s);
	}
	EnableMenuItem(GetMenu(hWnd),IDM_FILESAVE,MF_ENABLED);
	EnableMenuItem(GetMenu(hWnd),IDM_FILESAVEKPC,MF_ENABLED);
	EnableMenuItem(GetMenu(hWnd),IDM_PRINT,MF_ENABLED);
	EnableMenuItem(GetMenu(hWnd),IDM_EDITCOPY,MF_ENABLED);
	EnableMenuItem(GetMenu(hWnd),IDM_EDITPASTE2,MF_ENABLED);
	return f;
}

bool Open(HWND hWnd){
	OPENFILENAME file;
	char szFileName[512];
	lstrcpy(szFileName,"");
	memset(&file,0,sizeof(OPENFILENAME));
	file.lStructSize = sizeof(OPENFILENAME);
	file.hwndOwner = hWnd;
	file.lpstrFilter = "摜\0*.bmp;*.jpeg;*.jpg;*.kpc\0ׂ(*.*)\0*.*\0";
	file.nFilterIndex = 1;
	file.lpstrFile = szFileName;
	file.nMaxFile = 512;
	file.lpstrTitle = "ǂݍ";
	file.lpstrDefExt = "bmp";
	file.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	if (GetOpenFileName(&file)==0) return false;
	return Load(szFileName,hWnd);
}

bool Print(HWND hWnd){
	DOCINFO di;
	PRINTDLG pd;
	ZeroMemory(&di,sizeof(DOCINFO));
	ZeroMemory(&pd,sizeof(PRINTDLG));
	di.cbSize=sizeof(DOCINFO);
	di.lpszDocName="K-Viewer";
	pd.lStructSize=sizeof(PRINTDLG);
	pd.hwndOwner=hWnd;
	pd.Flags=PD_COLLATE | PD_HIDEPRINTTOFILE | PD_RETURNDC;
	pd.nCopies=1;
	if (0)
		pd.Flags|=PD_SELECTION;
	else
		pd.Flags|=PD_NOSELECTION;
	if (!PrintDlg(&pd))
		return false;
	int psx,psy;
	psx=GetDeviceCaps(pd.hDC,HORZRES);
	psy=GetDeviceCaps(pd.hDC,VERTRES);
	//SetAbortProc(pd.hDC,DlgProc);
	StartDoc(pd.hDC,&di);
	StartPage(pd.hDC);

	//AXyNgێg/k
	int x,y;
	x=psx;
	y=imgwnd->dib->sy*psx/imgwnd->dib->sx;
	if(y+64>psy){
		y=psy;
		x=imgwnd->dib->sx*psy/imgwnd->dib->sy;
	}
	SetStretchBltMode(pd.hDC,HALFTONE);
	StretchBlt(pd.hDC,0,0,x,y,imgwnd->dib->hdc,0,0,imgwnd->dib->sx,imgwnd->dib->sy,SRCCOPY);

	EndPage(pd.hDC);
	EndDoc(pd.hDC);
	DeleteDC(pd.hDC);
	return true;
}

bool Save(HWND hWnd){
	OPENFILENAME file;
	char szFileName[MAX_PATH];
	lstrcpy(szFileName,"");
	memset(&file,0,sizeof(OPENFILENAME));
	file.lStructSize = sizeof(OPENFILENAME);
	file.hwndOwner = hWnd;
	file.lpstrFilter = "rbg}bv\0*.bmp\0ׂ(*.*)\0*.*\0";
	file.nFilterIndex = 1;
	file.lpstrFile = szFileName;
	file.nMaxFile = MAX_PATH;
	file.lpstrTitle = "ۑ";
	file.lpstrDefExt = "bmp";
	file.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	if (GetSaveFileName(&file)==0) return false;

	CGrph CG;
	CG.bms = imgwnd->dib;
	return CG.SaveBMP(szFileName);
}



bool SaveKPC(CGrph CG,int mode,UINT flag,UINT col,char *lpAFile,HWND hWnd)
{
	OPENFILENAME file;
	char szFileName[512];
	lstrcpy(szFileName,"");
	memset(&file,0,sizeof(OPENFILENAME));
	file.lStructSize = sizeof(OPENFILENAME);
	file.hwndOwner = hWnd;
	file.lpstrFilter = "KPC`\0*.kpc\0ׂ(*.*)\0*.*\0";
	file.nFilterIndex = 1;
	file.lpstrFile = szFileName;
	file.nMaxFile = 512;
	file.lpstrTitle = "ۑ";
	file.lpstrDefExt = "kpc";
	file.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	if (GetSaveFileName(&file)==0) return false;

	return CG.SaveKPC(szFileName,mode,flag,col,lpAFile);
}

////////////////////////////////////////////////////////////////////////////
// Aԕۑ
class SeriesSave
{
public:
	static char SeriesFile[MAX_PATH]; // Aԕۑ̃t@C
	static int SeriesNo; // A
	static LRESULT CALLBACK SeriesDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);
	static void setFile(char *path);
	static void setNumber(int i);
	static bool save(HWND hWnd);
};
char SeriesSave::SeriesFile[MAX_PATH]; // Aԕۑ̃t@C
int SeriesSave::SeriesNo=1; // A

void SeriesSave::setNumber(int i)
{
	SeriesNo = i;
}

void SeriesSave::setFile(char *path)
{
	strcpy(SeriesFile,path);
}


//  AԐݒ_CAO
LRESULT CALLBACK SeriesSave::SeriesDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	switch(message)
	{
		case WM_INITDIALOG:
			{
				SetDlgItemText(hWnd,IDC_EDIT1,SeriesFile);
				SetDlgItemInt(hWnd,IDC_EDIT2,SeriesNo,FALSE);
			}
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDOK:
				{
					char inifile[MAX_PATH];
					GetIniFile((unsigned char*)inifile);
					GetDlgItemText(hWnd,IDC_EDIT1,SeriesFile,sizeof(SeriesFile));
					SeriesNo=GetDlgItemInt(hWnd,IDC_EDIT2,NULL,FALSE);
					WritePrivateProfileString("SeriesSave","SeriesFile",SeriesFile,inifile);
					EndDialog(hWnd, IDOK);
					break;
				}
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
				case IDC_BUTTON1:
					{
						OPENFILENAME file;
						char szFileName[512];
						lstrcpy(szFileName,"");
						memset(&file,0,sizeof(OPENFILENAME));
						file.lStructSize = sizeof(OPENFILENAME);
						file.hwndOwner = hWnd;
						file.lpstrFilter = "rbg}bv\0*.bmp\0ׂ(*.*)\0*.*\0";
						file.nFilterIndex = 1;
						file.lpstrFile = szFileName;
						file.nMaxFile = 512;
						file.lpstrTitle = "Aԕۑt@C";
						file.lpstrDefExt = "bmp";
						file.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
						file.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
						if (GetSaveFileName(&file)==0) break;
						SetDlgItemText(hWnd,IDC_EDIT1,szFileName);
					}
					break;
			}
			break;
		case WM_DESTROY:
			return 0;
	}
	return FALSE;
}

bool SeriesSave::save(HWND hWnd)
{
	char szFileName[MAX_PATH];
	char tail[MAX_PATH];
	if (!*SeriesFile)
		DialogBox(hInst,MAKEINTRESOURCE(IDD_SERIESCFG),hWnd,(DLGPROC)SeriesDlgProc);
	if (!*SeriesFile)
		return false;

	strcpy(szFileName,SeriesFile);

	char *p=strrchr(szFileName,'.');
	if (!p) p=szFileName+strlen(szFileName);
	strcpy(tail,p);
	itoa(SeriesNo,p,10);
	strcat(szFileName,tail);

	CGrph CG;
	CG.bms = imgwnd->dib;
	if (!CG.SaveBMP(szFileName)) return false;

	SeriesNo++;
	return true;
}



////////////////////////////////////////////////////////////////////////////
// t@CXg

class FileList
{
	vector<string> files;
	int curpos;
	char curdir[MAX_PATH];
public:
	bool prevFile(HWND hWnd);
	bool nextFile(HWND hWnd);
	bool refresh(char *file); // Xgč쐬
	FileList(){curpos=0;curdir[0]='\0';}
} flist;

bool FileList::refresh(char *path)
{
	if ( (!path) || *path=='\0' ) return false;

	// path  fBNg\*  t@C ɕ
	char dir[MAX_PATH];
	char file[MAX_PATH];
	int p=0,i;
	unsigned int l=strlen(path);
	for (i=0;i<l;i++) {
		//QoCgpc
		if ((unsigned char)((path[i]^0x20)-0xA1)<=0x3B) {
			i++;
			continue;
		}
		if (path[i]=='\\') p=i;
	}
	if (!p) return false;

	strcpy(dir,path);
	strcpy(file,dir+p+1);
	strcpy(dir+p+1,"*.*");

	memcpy(curdir,path,p+1);
	curdir[p+1]='\0';

	files.clear();
	curpos = 0;

	// t@CXg
	WIN32_FIND_DATA w32FindData;
	HANDLE hFind = FindFirstFile(dir,&w32FindData);
	if(hFind==INVALID_HANDLE_VALUE) return false;
	do {
		if(!(w32FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)){
			// ʏt@CȂ烊Xgɒǉ
			if (stricmp(w32FindData.cFileName,file)==0) { // ݂̃t@C
				curpos = files.size();
			}
			strcpy(dir+p+1,w32FindData.cFileName);
			if (CGrph::IsLoadable(dir)) { // ǂݍ݉\
				files.push_back(w32FindData.cFileName);
			}
		}
	} while(FindNextFile(hFind,&w32FindData));

	FindClose(hFind);
	return true;
}


bool FileList::prevFile(HWND hWnd)
{
	if (memcpy(curdir,CurrentFile,strlen(curdir)))
		refresh(CurrentFile);

	if (files.size()<=0) return false;
	char file[MAX_PATH];

	curpos--;
	if (curpos<0) curpos=files.size()-1;

	strcpy(file,curdir);
	strcat(file,files[curpos].c_str());

	Load(file,hWnd);
	return true;
}

bool FileList::nextFile(HWND hWnd)
{
	if (memcpy(curdir,CurrentFile,strlen(curdir)))
		refresh(CurrentFile);

	if (files.size()<=0) return false;
	char file[MAX_PATH];

	curpos++;
	if (curpos>=files.size()) curpos=0;

	strcpy(file,curdir);
	strcat(file,files[curpos].c_str());

	Load(file,hWnd);
	return true;
}

////////////////////////////////////////////////////////////////////////////


// DDER[obN֐
HWND hMWnd;

HDDEDATA CALLBACK DdeServProc(UINT uType, UINT uFmt,
    HCONV hConv, HSZ hszTpc1, HSZ hszTpc2, HDDEDATA hdata,
    DWORD dwData1, DWORD dwData2)
{
    char szBuffer[256];
	char szPath[MAX_PATH];
//    HDDEDATA hData;

    switch (uType) {
        case XTYP_CONNECT: //ڑ
            // hszTpc2:T[rX hszTpc1:gsbN
            DdeQueryString(ddeInst, hszTpc2, szBuffer, sizeof(szBuffer), CP_WINANSI);
            if (strcmp(szBuffer, "kwViewer") != 0)
                return (HDDEDATA)FALSE;
            DdeQueryString(ddeInst, hszTpc1, szBuffer, sizeof(szBuffer), CP_WINANSI);
            if (strcmp(szBuffer, "FILE_OPEN") != 0)
                return (HDDEDATA)FALSE;
			//MessageBox(hMWnd,"OK","DDE",MB_OK);
            return (HDDEDATA)TRUE;
/*        case XTYP_REQUEST:
            // hszTpc2: hsz1:gsbN
            DdeQueryString(ddeInst, hszTpc2, szBuffer, sizeof(szBuffer), CP_WINANSI);
            if (strcmp(szBuffer, "K-View") != 0)
                return (HDDEDATA)FALSE;
            DdeQueryString(ddeInst, hszTpc1, szBuffer, sizeof(szBuffer), CP_WINANSI);
            if (strcmp(szBuffer, "FILE_NAME") != 0)
                return (HDDEDATA)FALSE;
            hData =    DdeCreateDataHandle(ddeInst, (LPBYTE)szData, strlen(szData)+1, 0, hszTpc2, CF_TEXT, 0);
            return hData;
*/
		case XTYP_POKE:
			// hszTpc2: hszTpc1:gsbN
            DdeQueryString(ddeInst, hszTpc2, szBuffer, sizeof(szBuffer), CP_WINANSI);
            if (strcmp(szBuffer, "FILE_NAME") != 0)
                return (HDDEDATA)FALSE;
            DdeQueryString(ddeInst, hszTpc1, szBuffer, sizeof(szBuffer), CP_WINANSI);
            if (strcmp(szBuffer, "FILE_OPEN") != 0)
                return (HDDEDATA)FALSE;
            DdeGetData(hdata, (LPBYTE)szPath, sizeof(szPath), 0);
			SetAbsForegroundWindow(hMWnd);
			Load(szPath,hMWnd);
            return (HDDEDATA)DDE_FACK;
        default:
            return (HDDEDATA)FALSE;
    }
    return (HDDEDATA)FALSE;
}

bool DdeInit(HWND hWnd){
	hMWnd=hWnd;
	if (DdeInitialize(&ddeInst, DdeServProc, APPCLASS_STANDARD, 0) !=DMLERR_NO_ERROR) {
		MessageBox(hWnd, "Error: DdeInitialize", "kwViewer", MB_OK);
		return false;
	}
	hszService = DdeCreateStringHandle(ddeInst, "kwViewer", CP_WINANSI);
	hszTopic = DdeCreateStringHandle(ddeInst, "FILE_OPEN", CP_WINANSI);
	return true;
}

bool DdeEnd(){
	DdeFreeStringHandle(ddeInst, hszService);
	DdeFreeStringHandle(ddeInst, hszTopic);
	DdeUninitialize(ddeInst);
	ddeInst=NULL;
	return true;
}

void DdeServStart()
{
	DdeNameService(ddeInst, hszService, 0, DNS_REGISTER);
}

void DdeServEnd()
{
	DdeNameService(ddeInst, hszService, 0, DNS_UNREGISTER);
}

bool DdeSendFile(char *szPath,HWND hWnd)
{
	HDDEDATA hRet;
	HSZ hszMyItem;

	hConv = DdeConnect(ddeInst, hszService, hszTopic, NULL);
	if (DdeGetLastError(ddeInst) != DMLERR_NO_ERROR) { //NĂȂ
		return false;
	}

	hszMyItem = DdeCreateStringHandle(ddeInst, "FILE_NAME", CP_WINANSI);

	hRet = DdeClientTransaction((LPBYTE)szPath, strlen(szPath)+1,
			hConv, hszMyItem, CF_TEXT, XTYP_POKE, 10000, NULL);
    
	if (!hRet && DdeGetLastError(ddeInst) != DMLERR_NO_ERROR) {
		//MessageBox(hWnd, "DDE Error!", "K-View", MB_OK);
		//return false;
	} else if (hRet) {
		DdeFreeStringHandle(ddeInst, hszMyItem);
		DdeFreeDataHandle(hRet);
	}

	DdeDisconnect(hConv);
	hConv = NULL;
	return true;
}

HACCEL hAccel;
//  Gg[|Cg
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpCmdLine, int CmdShow)
{
	HWND hWnd;
	MSG msg;	 // bZ[WL[擾bZ[W
	WNDCLASS wc; // EChENXo^p̍\

	//  EChENXo^
	wc.style		=CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc	=WindowProc;
	wc.cbClsExtra	=0;
	wc.cbWndExtra	=0;
	wc.hInstance	=hInstance;
	wc.hIcon		=LoadIcon(hInstance,MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor		=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName	=MAKEINTRESOURCE(IDR_MENU1);
	wc.lpszClassName="kwViewer";
	if(RegisterClass(&wc)==0)
		return  0;
	hInst=hInstance;

	wsize.x=GetSystemMetrics(SM_CXSCREEN)/2;
	wsize.y=GetSystemMetrics(SM_CYSCREEN)/2;

	// ݒǂݍ
	char inifile[MAX_PATH];
	GetIniFile((unsigned char*)inifile);

	char file[MAX_PATH];
	GetPrivateProfileString("SeriesSave","SeriesFile","*",file,MAX_PATH,inifile);
	if (*file=='*') *file='\0';
	SeriesSave::setFile(file);
	SeriesSave::setNumber(GetPrivateProfileInt("SeriesSave","SeriesNo",1,inifile));

	bool fitwindow=false;
	// EChE̕
	WINDOWPLACEMENT wp;
	if (GetPrivateProfileInt("K-Viewer","WinSavePos",0,inifile)) {
		memset(&wp,0,sizeof(WINDOWPLACEMENT));
		wp.length=sizeof(WINDOWPLACEMENT);
		//GetWindowPlacement(hWnd,&wp);
		wp.flags=0;
		wp.showCmd=GetPrivateProfileInt("K-Viewer","WinState",0,inifile);
		wp.rcNormalPosition.left
			= GetPrivateProfileInt("K-Viewer","WinRectL",0,inifile);
		wp.rcNormalPosition.top
			= GetPrivateProfileInt("K-Viewer","WinRectT",0,inifile);
		wp.rcNormalPosition.right
			= GetPrivateProfileInt("K-Viewer","WinRectR",0,inifile);
		wp.rcNormalPosition.bottom
			= GetPrivateProfileInt("K-Viewer","WinRectB",0,inifile);
		//SetWindowPlacement(hWnd,&wp);
		if(wp.showCmd == SW_SHOWMAXIMIZED){
			CmdShow = SW_SHOWMAXIMIZED;
		}
		wsize.x = max(200,wp.rcNormalPosition.right-wp.rcNormalPosition.left);
		wsize.y = max(64,wp.rcNormalPosition.bottom-wp.rcNormalPosition.top);

		
		if (GetPrivateProfileInt("K-Viewer","FitToWindow",0,inifile))
			fitwindow = true;
	}

	hWnd=CreateWindow("kwViewer",APP_NAME,
						WS_OVERLAPPEDWINDOW,
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						wsize.x,
						wsize.y,
						NULL,
						(HMENU)NULL,
						hInstance, 0);
	if(hWnd==NULL) return  0;

	MainWindow.SetHandle(hWnd);
	imgwnd = new ImageWindow(hWnd);
	imgwnd->fitToWindow(fitwindow);

	EnableMenuItem(GetMenu(hWnd),IDM_FILESAVE,MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd),IDM_FILESAVEKPC,MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd),IDM_PRINT,MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd),IDM_EDITCOPY,MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd),IDM_EDITPASTE2,MF_GRAYED);
	hAccel = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDR_ACCELERATOR1));

	CheckMenuItem(GetMenu(hWnd),IDM_VIEWFITWINDOW,
		(fitwindow?MF_CHECKED:MF_UNCHECKED) | MF_BYCOMMAND);

	DdeInit(hWnd);

	int f=false;
	if(lpCmdLine[0]){
		//MessageBox(hWnd,lpCmdLine,"debug",MB_OK);
		char p[1024];
		int i=0;
		if(lpCmdLine[0]=='"'){
			i=1;
		}
		strcpy(p,lpCmdLine+i);
		if(i){
			i=strlen(p);
			p[i-1]=0;
		}
		f=DdeSendFile(p,hWnd);
		if(!f)
			Load(p,hWnd);
		else{
			DdeEnd();
			DestroyWindow( hWnd );
		}
	}
	if(!f){
		DdeServStart();
		ShowWindow(hWnd,CmdShow);
		UpdateWindow(hWnd);
	}

	DragAcceptFiles(hWnd, TRUE);
	//  bZ[W[v
	while(GetMessage(&msg,NULL,0,0))
	{
		if(!twain_msg(&msg)){
			if (!TranslateAccelerator(hWnd, hAccel, &msg)) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
	}
	DdeEnd();
	return  (int)msg.wParam;
}


//  EChEvV[W
LRESULT CALLBACK WindowProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	static PAINTSTRUCT ps;
	static POINT pt;
	switch(message)
	{
		case WM_CREATE:
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case TWAIN_SUCCESS:
					MainWindow.WinResize();
					EnableMenuItem(GetMenu(hWnd),IDM_FILESAVE,MF_ENABLED);
					EnableMenuItem(GetMenu(hWnd),IDM_FILESAVEKPC,MF_ENABLED);
					EnableMenuItem(GetMenu(hWnd),IDM_PRINT,MF_ENABLED);
					EnableMenuItem(GetMenu(hWnd),IDM_EDITCOPY,MF_ENABLED);
					EnableMenuItem(GetMenu(hWnd),IDM_EDITPASTE2,MF_ENABLED);
					//
					if (lParam==3) {
						Print(hWnd);
					} else if (lParam==4) {
						SeriesSave::save(hWnd);
					}
					break;
				case IDM_ABOUT:
					MessageBox(hWnd,APP_VER "\n"
						"\tCopyright 2002-2006 K-K","About " APP_NAME,MB_OK);
					break;
				case IDM_PRINT:
					Print(hWnd);	break;
				case IDM_FILEOPEN:
					Open(hWnd);		break;
				case IDM_FILESAVE:
					Save(hWnd);		break;
				case IDM_FILESERIES:
					SeriesSave::save(hWnd);	break;
				case IDM_FILESERIESCFG:
					DialogBox(hInst,MAKEINTRESOURCE(IDD_SERIESCFG),hWnd,(DLGPROC)SeriesSave::SeriesDlgProc);
					break;
				case IDM_FILENEXT:
					flist.nextFile(hWnd);
					break;
				case IDM_FILEPREV:
					flist.prevFile(hWnd);
					break;
				case IDM_FILESAVEKPC:
					DialogBox(hInst,MAKEINTRESOURCE(IDD_DLGKPC),hWnd,(DLGPROC)KPCDlgProc);
					break;
				case IDM_FILETWGET:
					twain_get(hWnd,imgwnd->dib,1,0);
				//	WinResize(hWnd);
					break;
				case IDM_FILETWSEL:
					twain_select(hWnd,NULL);
					break;
				case IDM_EDITCOPY:
					{
					HDC hdc = GetDC(hWnd);
					HDC hdc_mem = CreateCompatibleDC(hdc);
					HBITMAP hBitmap=CreateCompatibleBitmap(hdc, imgwnd->dib->sx, imgwnd->dib->sy);
					SelectObject(hdc_mem, hBitmap);
					BitBlt(hdc_mem,0,0,imgwnd->dib->sx, imgwnd->dib->sy,imgwnd->dib->hdc,0,0,SRCCOPY);
					OpenClipboard(hWnd);
					EmptyClipboard();
					SetClipboardData(CF_BITMAP, hBitmap);
					CloseClipboard();
					DeleteDC(hdc_mem);
					ReleaseDC(hWnd,hdc);
					break;
					}
				case IDM_EDITPASTE:
					{
					if (IsClipboardFormatAvailable(CF_BITMAP)) {
						imgwnd->dib->Delete();
						BITMAP bm;
						HDC hdc = GetDC(hWnd);
						HDC hdc_mem = CreateCompatibleDC(hdc);
						OpenClipboard(hWnd);
						HBITMAP hBitmap=(HBITMAP)GetClipboardData(CF_BITMAP);
						GetObject(hBitmap, sizeof(BITMAP), (LPSTR)&bm);
						SelectObject(hdc_mem, hBitmap);
						imgwnd->dib->Create(bm.bmWidth, bm.bmHeight,0);
						BitBlt(imgwnd->dib->hdc, 0, 0, bm.bmWidth, bm.bmHeight, hdc_mem, 0, 0, SRCCOPY);
						CloseClipboard();
						DeleteDC(hdc_mem);
						ReleaseDC(hWnd,hdc);
						MainWindow.WinResize();
						EnableMenuItem(GetMenu(hWnd),IDM_FILESAVE,MF_ENABLED);
						EnableMenuItem(GetMenu(hWnd),IDM_FILESAVEKPC,MF_ENABLED);
						EnableMenuItem(GetMenu(hWnd),IDM_PRINT,MF_ENABLED);
						EnableMenuItem(GetMenu(hWnd),IDM_EDITCOPY,MF_ENABLED);
						EnableMenuItem(GetMenu(hWnd),IDM_EDITPASTE2,MF_ENABLED);
					}
					break;
					}
				case IDM_EDITPASTE2:
					{
					if(imgwnd->dib->flag==0){
						MessageBox(hWnd,"摜ǂݍ܂Ă܂","G[",MB_OK);
						break;
					}
					if (IsClipboardFormatAvailable(CF_BITMAP)) {
						BITMAP bm;
						HDC hdc = GetDC(hWnd);
						HDC hdc_mem = CreateCompatibleDC(hdc);
						OpenClipboard(hWnd);
						HBITMAP hBitmap=(HBITMAP)GetClipboardData(CF_BITMAP);
						GetObject(hBitmap, sizeof(BITMAP), (LPSTR)&bm);
						SelectObject(hdc_mem, hBitmap);
						BitBlt(imgwnd->dib->hdc, 0, 0, bm.bmWidth, bm.bmHeight, hdc_mem, 0, 0, SRCCOPY);
						BitBlt(hdc, 0, 0, bm.bmWidth, bm.bmHeight, hdc_mem, 0, 0, SRCCOPY);
						CloseClipboard();
						DeleteDC(hdc_mem);
						ReleaseDC(hWnd,hdc);
					}
					break;
					}
				case IDM_EDITROTATE_L:
					imgwnd->dib->Rotate(-1);
					MainWindow.WinResize();
					break;
				case IDM_EDITROTATE_R:
					imgwnd->dib->Rotate(1);
					MainWindow.WinResize();
					break;
				case IDM_EDITRESIZE:
					if(DialogBox(hInst,MAKEINTRESOURCE(IDD_RESIZE),hWnd,(DLGPROC)ReSizeDlgProc)
						==IDOK){
						MainWindow.WinResize();
					}
					break;
				case IDM_EDITHSV:
					if(DialogBox(hInst,MAKEINTRESOURCE(IDD_DIALOG1),hWnd,(DLGPROC)ChgHSVDlgProc)
						==IDOK){
						MainWindow.WinResize();
					}
					break;
				case IDM_EDITBCG:
					if(DialogBox(hInst,MAKEINTRESOURCE(IDD_DIALOG2),hWnd,(DLGPROC)ChgBCGDlgProc)
						==IDOK){
						MainWindow.WinResize();
					}
					break;
				case IDM_EDITCONFIG:
					if(DialogBox(hInst,MAKEINTRESOURCE(IDD_CONFIG),hWnd,(DLGPROC)ConfigDlgProc)
						==IDOK){
						MainWindow.WinResize();
					}
					break;
				case IDM_VIEWFITWINDOW:
					{
						bool fitwindow=!imgwnd->isFitToWindow();
						CheckMenuItem(GetMenu(hWnd),IDM_VIEWFITWINDOW,
							(fitwindow?MF_CHECKED:MF_UNCHECKED) | MF_BYCOMMAND);
						imgwnd->fitToWindow(fitwindow);
					}
					break;
				case IDM_VIEWSTATUS:
					{
						bool flag=!MainWindow.fStatus;
						CheckMenuItem(GetMenu(hWnd),IDM_VIEWSTATUS,
							(flag?MF_CHECKED:MF_UNCHECKED) | MF_BYCOMMAND);
						MainWindow.setStatus(flag);
					}
					break;
				case IDM_EXIT:
				   DestroyWindow( hWnd );
				   break;
			}
			break;
		case WM_DROPFILES:
			{
				char lpPath[1024];
				DragQueryFile((HDROP)wParam, 0, lpPath, sizeof(lpPath));
				Load(lpPath,hWnd);
			break;
			}
		case WM_SIZE:
			{
				int sh=0;
				if (MainWindow.fStatus) {
					RECT rt;
					SendMessage(MainWindow.hStatus, WM_SIZE, wParam, lParam);
					GetWindowRect(MainWindow.hStatus,&rt);
					sh = rt.bottom-rt.top;
				}
				imgwnd->setSize(LOWORD(lParam),HIWORD(lParam)-sh);
			}
			break;
		case WM_SIZING:
			{
				RECT rt;
				int x=wsize.x,y=wsize.y,sh=0;
				int ws=GetWindowLong(hWnd,GWL_STYLE);
				if(ws & WS_HSCROLL)
					y+=GetSystemMetrics(SM_CYHSCROLL);
				if(ws & WS_VSCROLL)
					x+=GetSystemMetrics(SM_CXVSCROLL);

				if (MainWindow.fStatus) {
					GetWindowRect(MainWindow.hStatus,&rt);
					sh=rt.bottom-rt.top;
				}
				y+=sh;
				((RECT*)lParam)->right=min(x+((RECT*)lParam)->left,((RECT*)lParam)->right);
				((RECT*)lParam)->bottom=min(y+((RECT*)lParam)->top,((RECT*)lParam)->bottom);
				GetClientRect( hWnd, &rt );
				imgwnd->setSize(rt.right,rt.bottom-sh);
			}
			break;
		case WM_CLOSE:
			{
				char inifile[MAX_PATH];
				GetIniFile((unsigned char*)inifile);
				char s[8];
				WritePrivateProfileString("SeriesSave","SeriesNo",
					itoa(SeriesSave::SeriesNo,s,10),inifile);
				WINDOWPLACEMENT wp;
				wp.length=sizeof(WINDOWPLACEMENT);
				GetWindowPlacement(hWnd,&wp);
				WritePrivateProfileString("K-Viewer","WinState",
					itoa(wp.showCmd,s,10),inifile);
				WritePrivateProfileString("K-Viewer","WinRectL",
					itoa(wp.rcNormalPosition.left,s,10),inifile);
				WritePrivateProfileString("K-Viewer","WinRectT",
					itoa(wp.rcNormalPosition.top,s,10),inifile);
				WritePrivateProfileString("K-Viewer","WinRectR",
					itoa(wp.rcNormalPosition.right,s,10),inifile);
				WritePrivateProfileString("K-Viewer","WinRectB",
					itoa(wp.rcNormalPosition.bottom,s,10),inifile);
				WritePrivateProfileString("K-Viewer","FitToWindow",
					itoa(imgwnd->isFitToWindow()?1:0,s,10),inifile);
			}
			break;
		case WM_DESTROY:
			if(ddeInst)DdeServEnd();
			twain_free();
			PostQuitMessage(0);
			return  0;
	}
	return  DefWindowProc(hWnd,message,wParam,lParam);
}


//  F_CAO
LRESULT CALLBACK ChgHSVDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	static CBitmap tbms;
	static HBITMAP hBitmap;
	static HBITMAP hBitmap2;
	switch(message)
	{
		case WM_INITDIALOG:
			{
				tbms.Create(160,120,0);
				hBitmap=CreateCompatibleBitmap(tbms.hdc,160,120);
				hBitmap2=CreateCompatibleBitmap(tbms.hdc,160,120);
				HDC hDC=CreateCompatibleDC(tbms.hdc);
				SelectObject(hDC,hBitmap);
				SetStretchBltMode(hDC,STRETCH_HALFTONE);
				StretchBlt(hDC,0,0,tbms.sx,tbms.sy,
					imgwnd->dib->hdc,0,0,imgwnd->dib->sx,imgwnd->dib->sy,SRCCOPY);
				DeleteDC(hDC);
				SendDlgItemMessage(hWnd,IDC_PREV1,STM_SETIMAGE,IMAGE_BITMAP,(LPARAM)hBitmap);
				//
				SetDlgItemInt(hWnd,IDC_CHGH ,0,TRUE);
				SetDlgItemInt(hWnd,IDC_CHGS ,100,TRUE);
				SetDlgItemInt(hWnd,IDC_CHGV ,100,TRUE);
				SendMessage(GetDlgItem(hWnd,IDC_SLIDER1),TBM_SETRANGE,(WPARAM)TRUE,MAKELPARAM(-240,240));
				SendMessage(GetDlgItem(hWnd,IDC_SLIDER1),TBM_SETPOS,(WPARAM)TRUE,(LPARAM)0);
				SendMessage(GetDlgItem(hWnd,IDC_SLIDER2),TBM_SETRANGE,(WPARAM)TRUE,MAKELPARAM(0,200));
				SendMessage(GetDlgItem(hWnd,IDC_SLIDER2),TBM_SETPOS,(WPARAM)TRUE,(LPARAM)100);
				SendMessage(GetDlgItem(hWnd,IDC_SLIDER3),TBM_SETRANGE,(WPARAM)TRUE,MAKELPARAM(0,200));
				SendMessage(GetDlgItem(hWnd,IDC_SLIDER3),TBM_SETPOS,(WPARAM)TRUE,(LPARAM)100);
			}
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_CHGH:
				case IDC_CHGS:
				case IDC_CHGV:
					if(HIWORD(wParam)==EN_UPDATE){
						//BitBlt(tbms.hdc,0,0,160,120,CG.bms->hdc,0,0,SRCCOPY);
						int h=GetDlgItemInt(hWnd,IDC_CHGH ,NULL,TRUE);
						int s=GetDlgItemInt(hWnd,IDC_CHGS ,NULL,TRUE);
						int v=GetDlgItemInt(hWnd,IDC_CHGV ,NULL,TRUE);
						if(s>65535 || v>65535){
							break;
						}
						HDC hDC=CreateCompatibleDC(tbms.hdc);
						SelectObject(hDC,hBitmap);
						BitBlt(tbms.hdc,0,0,160,120,hDC,0,0,SRCCOPY);
						tbms.ChangeTone(h*1024/60,s*1024/100,v*1024/100);
						SelectObject(hDC,hBitmap2);
						BitBlt(hDC,0,0,160,120,tbms.hdc,0,0,SRCCOPY);
						DeleteDC(hDC);
						SendDlgItemMessage(hWnd,IDC_PREV2,STM_SETIMAGE,IMAGE_BITMAP,(LPARAM)hBitmap2);
					}
					break;
				case IDOK:
				{
					int h=GetDlgItemInt(hWnd,IDC_CHGH ,NULL,TRUE);
					int s=GetDlgItemInt(hWnd,IDC_CHGS ,NULL,TRUE);
					int v=GetDlgItemInt(hWnd,IDC_CHGV ,NULL,TRUE);
					if(s>65535 || v>65535){
						MessageBox(hWnd,"lsłD","Error",MB_OK);
						break;
					}
					imgwnd->dib->ChangeTone(h*1024/60,s*1024/100,v*1024/100);
					EndDialog(hWnd, IDOK);
					break;
				}
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
			}
			break;
		case WM_HSCROLL:
			if((HWND)lParam==GetDlgItem(hWnd,IDC_SLIDER1)){
				SetDlgItemInt(hWnd,IDC_CHGH ,(UINT)SendMessage((HWND)lParam,TBM_GETPOS,0,0),TRUE);
			}
			if((HWND)lParam==GetDlgItem(hWnd,IDC_SLIDER2)){
				SetDlgItemInt(hWnd,IDC_CHGS ,SendMessage((HWND)lParam,TBM_GETPOS,0,0),TRUE);
			}
			if((HWND)lParam==GetDlgItem(hWnd,IDC_SLIDER3)){
				SetDlgItemInt(hWnd,IDC_CHGV ,SendMessage((HWND)lParam,TBM_GETPOS,0,0),TRUE);
			}
			break;
		case WM_DESTROY:
			tbms.Delete();
			return 0;
	}
	return FALSE;
}

//  RgXg_CAO
LRESULT CALLBACK ChgBCGDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	static CBitmap tbms;
	static HBITMAP hBitmap;
	static HBITMAP hBitmap2;
	switch(message)
	{
		case WM_INITDIALOG:
			{
				tbms.Create(160,120,0);
				hBitmap=CreateCompatibleBitmap(tbms.hdc,160,120);
				hBitmap2=CreateCompatibleBitmap(tbms.hdc,160,120);
				HDC hDC=CreateCompatibleDC(tbms.hdc);
				SelectObject(hDC,hBitmap);
				SetStretchBltMode(hDC,STRETCH_HALFTONE);
				StretchBlt(hDC,0,0,tbms.sx,tbms.sy,
							imgwnd->dib->hdc,0,0,imgwnd->dib->sx,imgwnd->dib->sy,SRCCOPY);
				DeleteDC(hDC);
				SendDlgItemMessage(hWnd,IDC_PREV1,STM_SETIMAGE,IMAGE_BITMAP,(LPARAM)hBitmap);
				//
				SetDlgItemInt(hWnd,IDC_CHCB ,0,TRUE);
				SetDlgItemInt(hWnd,IDC_CHCC ,100,TRUE);
				SetDlgItemInt(hWnd,IDC_CHCG ,100,TRUE);
				SendMessage(GetDlgItem(hWnd,IDC_SLIDER1),TBM_SETRANGE,(WPARAM)TRUE,MAKELPARAM(-100,100));
				SendMessage(GetDlgItem(hWnd,IDC_SLIDER1),TBM_SETPOS,(WPARAM)TRUE,(LPARAM)0);
				SendMessage(GetDlgItem(hWnd,IDC_SLIDER2),TBM_SETRANGE,(WPARAM)TRUE,MAKELPARAM(0,200));
				SendMessage(GetDlgItem(hWnd,IDC_SLIDER2),TBM_SETPOS,(WPARAM)TRUE,(LPARAM)100);
				SendMessage(GetDlgItem(hWnd,IDC_SLIDER3),TBM_SETRANGE,(WPARAM)TRUE,MAKELPARAM(0,200));
				SendMessage(GetDlgItem(hWnd,IDC_SLIDER3),TBM_SETPOS,(WPARAM)TRUE,(LPARAM)100);
			}
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_CHCB:
				case IDC_CHCC:
				case IDC_CHCG:
					if(HIWORD(wParam)==EN_UPDATE){
						int h=GetDlgItemInt(hWnd,IDC_CHCB ,NULL,TRUE);
						int s=GetDlgItemInt(hWnd,IDC_CHCC ,NULL,TRUE);
						int v=GetDlgItemInt(hWnd,IDC_CHCG ,NULL,TRUE);
						if(s>65535 || v>65535){
							break;
						}
						HDC hDC=CreateCompatibleDC(tbms.hdc);
						SelectObject(hDC,hBitmap);
						BitBlt(tbms.hdc,0,0,160,120,hDC,0,0,SRCCOPY);
						tbms.ChangeBrt(h*1024/60,s*1024/100,v*1024/100);
						SelectObject(hDC,hBitmap2);
						BitBlt(hDC,0,0,160,120,tbms.hdc,0,0,SRCCOPY);
						DeleteDC(hDC);
						SendDlgItemMessage(hWnd,IDC_PREV2,STM_SETIMAGE,IMAGE_BITMAP,(LPARAM)hBitmap2);
					}
					break;
				case IDOK:
				{
					int h=GetDlgItemInt(hWnd,IDC_CHCB ,NULL,TRUE);
					int s=GetDlgItemInt(hWnd,IDC_CHCC ,NULL,TRUE);
					int v=GetDlgItemInt(hWnd,IDC_CHCG ,NULL,TRUE);
					if(s>65535 || v>65535){
						MessageBox(hWnd,"lsłD","Error",MB_OK);
						break;
					}
					imgwnd->dib->ChangeBrt(h*1024/60,s*1024/100,v*1024/100);
					EndDialog(hWnd, IDOK);
					break;
				}
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
			}
			break;
		case WM_HSCROLL:
			if((HWND)lParam==GetDlgItem(hWnd,IDC_SLIDER1)){
				//if(LOWORD(wParam)==TB_THUMBPOSITION){
				//	SetDlgItemInt(hWnd,IDC_CHCC ,HIWORD(wParam),TRUE);
				//}
				SetDlgItemInt(hWnd,IDC_CHCB ,SendMessage((HWND)lParam,TBM_GETPOS,0,0),TRUE);
			}
			if((HWND)lParam==GetDlgItem(hWnd,IDC_SLIDER2)){
				SetDlgItemInt(hWnd,IDC_CHCC ,SendMessage((HWND)lParam,TBM_GETPOS,0,0),TRUE);
			}
			if((HWND)lParam==GetDlgItem(hWnd,IDC_SLIDER3)){
				SetDlgItemInt(hWnd,IDC_CHCG ,SendMessage((HWND)lParam,TBM_GETPOS,0,0),TRUE);
			}
			break;
		case WM_DESTROY:
			tbms.Delete();
			return 0;
	}
	return FALSE;
}

//  TCY_CAO
LRESULT CALLBACK ReSizeDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	static int flag, resizemode;
	switch(message)
	{
		case WM_INITDIALOG:
			{
				flag=false;
				resizemode=0;
				char *m1[]={"sNZ","p[Ze[W",NULL};
				int i=0;
				while(m1[i]){
					SendMessage(GetDlgItem(hWnd, IDC_RSMODE), CB_INSERTSTRING,
						(WPARAM)i, (LPARAM)m1[i]);
					i++;
				}
				SendMessage(GetDlgItem(hWnd, IDC_RSMODE), CB_SETCURSEL, (WPARAM)0, 0L);
				char s[16];
				wsprintf(s,"%dx%d",imgwnd->dib->sx,imgwnd->dib->sy);
				SetDlgItemText(hWnd,IDC_RSCSIZE,s);
				SetDlgItemInt(hWnd,IDC_RSWIDTH ,imgwnd->dib->sx,FALSE);
				SetDlgItemInt(hWnd,IDC_RSHEIGHT,imgwnd->dib->sy,FALSE);
				CheckDlgButton(hWnd,IDC_RSASPECT,BST_CHECKED);
				SetFocus(GetDlgItem(hWnd,IDC_RSWIDTH));
			//	itoa(imgwnd->dib->sx,s,10);
			//	SetWindowText(GetDlgItem(hWnd, IDC_RSWIDTH),s);
			//	itoa(imgwnd->dib->sy,s,10);
			//	SetWindowText(GetDlgItem(hWnd, IDC_RSHEIGHT),s);
				flag=true;
			}
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_RSWIDTH:
					if(HIWORD(wParam)==EN_UPDATE &&flag){
						if(IsDlgButtonChecked(hWnd,IDC_RSASPECT)){
							if(resizemode==0){
								int w=GetDlgItemInt(hWnd,IDC_RSWIDTH ,NULL,FALSE);
								int h=GetDlgItemInt(hWnd,IDC_RSHEIGHT,NULL,FALSE);
								if(h != imgwnd->dib->sy*w/imgwnd->dib->sx){
									flag=false;
									SetDlgItemInt(hWnd,IDC_RSHEIGHT,imgwnd->dib->sy*w/imgwnd->dib->sx,FALSE);
									flag=true;
								}
							}else{
								int sw=GetDlgItemInt(hWnd,IDC_RSWIDTH ,NULL,FALSE);
								flag=false;
								SetDlgItemInt(hWnd,IDC_RSHEIGHT,sw,FALSE);
								flag=true;
							}
						}
					}
					break;
				case IDC_RSHEIGHT:
					if(HIWORD(wParam)==EN_UPDATE &&flag){
						if(IsDlgButtonChecked(hWnd,IDC_RSASPECT)){
							if(resizemode==0){
								int w=GetDlgItemInt(hWnd,IDC_RSWIDTH ,NULL,FALSE);
								int h=GetDlgItemInt(hWnd,IDC_RSHEIGHT,NULL,FALSE);
								if(w != imgwnd->dib->sx*h/imgwnd->dib->sy){
									flag=false;
									SetDlgItemInt(hWnd,IDC_RSWIDTH,imgwnd->dib->sx*h/imgwnd->dib->sy,FALSE);
									flag=true;
								}
							}else{
								int sh=GetDlgItemInt(hWnd,IDC_RSHEIGHT ,NULL,FALSE);
								flag=false;
								SetDlgItemInt(hWnd,IDC_RSWIDTH,sh,FALSE);
								flag=true;
							}
						}
					}
					break;
				case IDC_RSMODE:
					if(HIWORD(wParam)==CBN_SELCHANGE){
						int mode=(int)SendMessage(GetDlgItem(hWnd,IDC_RSMODE), CB_GETCURSEL, 0L, 0L);
						int w=GetDlgItemInt(hWnd,IDC_RSWIDTH ,NULL,FALSE);
						int h=GetDlgItemInt(hWnd,IDC_RSHEIGHT,NULL,FALSE);
						char *s=NULL;
						if(mode==1 && resizemode==0){
							s="%";
							w=w*100/imgwnd->dib->sx;
							h=h*100/imgwnd->dib->sy;
						}else if(mode==0 && resizemode==1){
							s="px";
							w=imgwnd->dib->sx*w/100;
							h=imgwnd->dib->sy*h/100;
						}
						if(s){
							flag=false;
							SetDlgItemInt(hWnd,IDC_RSWIDTH ,w,FALSE);
							SetDlgItemInt(hWnd,IDC_RSHEIGHT,h,FALSE);
							SetDlgItemText(hWnd,IDC_RSUNIT1,s);
							SetDlgItemText(hWnd,IDC_RSUNIT2,s);
							resizemode=mode;
							flag=true;
						}
					}
					break;
				case IDOK:
				{
					int w=GetDlgItemInt(hWnd,IDC_RSWIDTH ,NULL,FALSE);
					int h=GetDlgItemInt(hWnd,IDC_RSHEIGHT,NULL,FALSE);
					if(resizemode==1){
						w=imgwnd->dib->sx*w/100;
						h=imgwnd->dib->sy*h/100;
					}
					if(w==0 || h==0 || w>65535 || h>65535){
						MessageBox(hWnd,"TCYsłD","Error",MB_OK);
						break;
					}
					if(imgwnd->dib->sx!=w || imgwnd->dib->sy!=h){
						CGrph CG2;
						CG2.bms=new CBitmap;
						CG2.bms->Create(w,h,0);
						SetStretchBltMode(CG2.bms->hdc,STRETCH_HALFTONE);
						StretchBlt(CG2.bms->hdc,0,0,w,h,
							imgwnd->dib->hdc,0,0,imgwnd->dib->sx,imgwnd->dib->sy,SRCCOPY);
						delete imgwnd->dib;
						imgwnd->dib=CG2.bms;
					}
					EndDialog(hWnd, IDOK);
					break;
				}
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
			}
			break;
		case WM_DESTROY:
			return 0;
	}
	return FALSE;
}


//  KPCŕۑ_CAO
LRESULT CALLBACK KPCDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	static char lpAFile[512];
	switch(message)
	{
		case WM_INITDIALOG:
			{
				lpAFile[0]=0;
				char *m1[]={"RGB","Y-yR-yB","O[XP[",NULL};
				char *m2[]={"Ȃ","F","`l摜",NULL};
				int i=0;
				while(m1[i]){
					SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_INSERTSTRING,
						(WPARAM)i, (LPARAM)m1[i]);
					i++;
				}
				SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_SETCURSEL, (WPARAM)1, 0L);
				i=0;
				while(m2[i]){
					SendMessage(GetDlgItem(hWnd, IDC_COMBO2), CB_INSERTSTRING,
						(WPARAM)i, (LPARAM)m2[i]);
					i++;
				}
				SendMessage(GetDlgItem(hWnd, IDC_COMBO2), CB_SETCURSEL, (WPARAM)0, 0L);
				CheckDlgButton(hWnd, IDC_CHKRLE, BST_CHECKED);
				CheckDlgButton(hWnd, IDC_CHKHUFF, BST_CHECKED);
				CheckDlgButton(hWnd, IDC_CHKDIFF, BST_CHECKED);
				SetDlgItemInt(hWnd,IDC_EDIT1,0,FALSE);
				SetDlgItemInt(hWnd,IDC_EDIT2,255,FALSE);
				SetDlgItemInt(hWnd,IDC_EDIT3,0,FALSE);

			}
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDOK:
				{
					int mode=(int)SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_GETCURSEL, 0L, 0L);
					int flag=(int)SendMessage(GetDlgItem(hWnd, IDC_COMBO2), CB_GETCURSEL, 0L, 0L);
					int frle=IsDlgButtonChecked(hWnd,IDC_CHKRLE);
					int fdiff=IsDlgButtonChecked(hWnd,IDC_CHKDIFF);
					int fhuff=IsDlgButtonChecked(hWnd,IDC_CHKHUFF);
					UINT col;
					col=(GetDlgItemInt(hWnd,IDC_EDIT1,NULL,FALSE)<<16)
						+(GetDlgItemInt(hWnd,IDC_EDIT2,NULL,FALSE)<<8)
						+GetDlgItemInt(hWnd,IDC_EDIT3,NULL,FALSE);
					CGrph CG;
					CG.bms = imgwnd->dib;
					SaveKPC(CG,mode,fdiff | frle<<1 | fhuff<<2 | flag<<8,col,lpAFile,hWnd);
					EndDialog(hWnd, IDOK);
					break;
				}
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
				case IDC_BUTTON1:
					{
						OPENFILENAME file;
						char szFileName[512];
						lstrcpy(szFileName,"");
						memset(&file,0,sizeof(OPENFILENAME));
						file.lStructSize = sizeof(OPENFILENAME);
						file.hwndOwner = hWnd;
						file.lpstrFilter = "摜\0*.bmp;*.jpeg;*.jpg;*.kpc\0ׂ(*.*)\0*.*\0";
						file.nFilterIndex = 1;
						file.lpstrFile = szFileName;
						file.nMaxFile = 512;
						file.lpstrTitle = "`lǂݍ";
						file.lpstrDefExt = "bmp";
						file.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
						if (GetOpenFileName(&file)==0) break;
						strcpy(lpAFile,szFileName);
					}
					break;
				case IDC_COMBO2:
					if(HIWORD(wParam)==CBN_SELCHANGE){
						int i=(int)SendMessage(GetDlgItem(hWnd, IDC_COMBO2), CB_GETCURSEL, 0L, 0L);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT1),i==1);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT2),i==1);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT3),i==1);
						EnableWindow(GetDlgItem(hWnd, IDC_BUTTON1),i==2);
					}
				break;
			}
		case WM_DESTROY:
			return 0;
	}
	return FALSE;
}
//  ݒ_CAO
LRESULT CALLBACK ConfigDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	static struct {
		char event[48];
		int cmd;
	} list[32];
	switch(message)
	{
		case WM_INITDIALOG:
			{
				HKEY hKey;
				ULONG s;
				RegCreateKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\StillImage\\Registered Applications",0,"",
					REG_OPTION_NON_VOLATILE,KEY_READ,NULL,&hKey,&s);
				if (RegQueryValueEx(hKey,"K-Viewer",NULL, NULL,NULL,NULL)==ERROR_SUCCESS) {
					CheckDlgButton(hWnd, IDC_CHECK1, BST_CHECKED);
				}
				RegCloseKey(hKey);

				char dat[4096];
				int i=0;
				char inifile[MAX_PATH];
				GetIniFile((unsigned char*)inifile);
				GetPrivateProfileString("EVENT",NULL,"?",dat,MAX_PATH,inifile);
				char *p=dat;
				while(*p && *p!='?'){
					strcpy(list[i].event,p);
					list[i].cmd=GetPrivateProfileInt("EVENT",p,0,inifile);
					SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_INSERTSTRING,
						(WPARAM)i, (LPARAM)list[i].event);
					i++;
					p+=strlen(p)+1;
				}
				list[i].event[0]='\0';
				SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_SETCURSEL, (WPARAM)0, 0L);

				i=0;
				char *m1[]={"Ȃ","XL","ȈՃXL","","Aԕۑ",NULL};
				while(m1[i]){
					SendMessage(GetDlgItem(hWnd, IDC_COMBO2), CB_INSERTSTRING,
						(WPARAM)i, (LPARAM)m1[i]);
					i++;
				}
				SendMessage(GetDlgItem(hWnd, IDC_COMBO2), CB_SETCURSEL, (WPARAM)list[0].cmd, 0L);

				// EChE̕
				if (GetPrivateProfileInt("K-Viewer","WinSavePos",0,inifile)) {
					CheckDlgButton(hWnd, IDC_CHECK2, BST_CHECKED);
				}
			}
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDOK:
				{
					char inifile[MAX_PATH];
					GetIniFile((unsigned char*)inifile);
					char s[8];
					int i=0;
					while(list[i].event[0]){
						WritePrivateProfileString("EVENT",list[i].event,itoa(list[i].cmd,s,10),inifile);
						i++;
					}
					int flag=IsDlgButtonChecked(hWnd,IDC_CHECK1);
					if (flag) {
						HKEY hKey;
						ULONG s;
						char cmd[MAX_PATH+64];
						GetModuleFileName(NULL,cmd,MAX_PATH);
						strcat(cmd," CMD:TWAIN\\%1 %2");
						RegCreateKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\StillImage\\Registered Applications",0,"",
							REG_OPTION_NON_VOLATILE,KEY_WRITE,NULL,&hKey,&s);
						RegSetValueEx(hKey,"K-Viewer",0,REG_SZ,(const UCHAR*)cmd,strlen(cmd)+1);
						RegCloseKey(hKey);
					} else {
						HKEY hKey;
						ULONG s;
						RegCreateKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\StillImage\\Registered Applications",0,"",
							REG_OPTION_NON_VOLATILE,KEY_WRITE,NULL,&hKey,&s);
						RegDeleteValue(hKey,"K-Viewer");
						RegCloseKey(hKey);
						//RegDeleteKey(HKEY_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\StillImage\\Registered Applications\\K-Viewer");
					}
					flag=IsDlgButtonChecked(hWnd,IDC_CHECK2);
					WritePrivateProfileString("K-Viewer","WinSavePos",itoa(flag,s,10),inifile);
					EndDialog(hWnd, IDOK);
					break;
				}
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
				case IDC_COMBO1:
					if(HIWORD(wParam)==CBN_SELCHANGE){
						int i=(int)SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_GETCURSEL, 0L, 0L);
						SendMessage(GetDlgItem(hWnd, IDC_COMBO2), CB_SETCURSEL, (WPARAM)list[i].cmd, 0L);
					}
					break;
				case IDC_COMBO2:
					if(HIWORD(wParam)==CBN_SELCHANGE){
						int i=(int)SendMessage(GetDlgItem(hWnd, IDC_COMBO2), CB_GETCURSEL, 0L, 0L);
						int j=(int)SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_GETCURSEL, 0L, 0L);
						list[j].cmd=i;
					}
					break;
			}
			break;
		case WM_DESTROY:
			return 0;
	}
	return FALSE;
}
