#include	<windows.h>
#include "Twain.h"
#define TWAIN_SUCCESS 0x7001

#include "image.h"

HMODULE hDSMDLL;
DSMENTRYPROC lpDSM_Entry;
TW_USERINTERFACE ui;
TW_IDENTITY appID,dsID;
HWND hWnd;
CBitmap *bms;
int mode=1;
UINT lparam;

bool twain_init(HWND hw){
	//TWAIN initialization
	hWnd=hw;
	TW_UINT16 twRC = TWRC_FAILURE;

	hDSMDLL=LoadLibrary("TWAIN_32.DLL");
	lpDSM_Entry=(DSMENTRYPROC)GetProcAddress(hDSMDLL, MAKEINTRESOURCE (1));

	dsID.Id=0;
	dsID.ProductName[0]='\0';
	//strcpy(dsID.ProductName,"TWAIN_32 Sample Source");

	appID.Id = 0; 				// init to 0, but Source Manager will assign real value
	appID.Version.MajorNum = 0;
	appID.Version.MinorNum = 39;
	appID.Version.Language = TWLG_JAPANESE;
	appID.Version.Country  = TWCY_JAPAN;
	lstrcpy (appID.Version.Info,  "K-View 0.4  03/17/2003");
	lstrcpy (appID.ProductName,   "KViewer");
	appID.ProtocolMajor = TWON_PROTOCOLMAJOR;
	appID.ProtocolMinor = TWON_PROTOCOLMINOR;
	appID.SupportedGroups =  DG_IMAGE | DG_CONTROL;
	lstrcpy (appID.Manufacturer,  "K-K");
	lstrcpy (appID.ProductFamily, "K-Viewer");

	twRC=lpDSM_Entry(&appID,NULL,DG_CONTROL,DAT_PARENT,MSG_OPENDSM,(TW_MEMREF)&hWnd);

	if(twRC != TWRC_SUCCESS)
		return false;

	mode=3;
	return true;
}

bool twain_free(){
	if(!hDSMDLL)
		return false;

	TW_UINT16 twRC = TWRC_FAILURE;
	twRC=lpDSM_Entry(&appID,NULL,DG_CONTROL,DAT_PARENT,MSG_CLOSEDSM,NULL);

	if(twRC != TWRC_SUCCESS)
		return false;


	FreeLibrary(hDSMDLL);
	hDSMDLL=NULL;
	mode=1;
	return true;
}


bool twain_select(HWND hw,char *name)
{
	if(mode==1)
		twain_init(hw);

	TW_UINT16 twRC = TWRC_FAILURE;
	TW_IDENTITY tdsid;
	memset(&tdsid, 0, sizeof(TW_IDENTITY));

	twRC = lpDSM_Entry(&appID,
				NULL,
				DG_CONTROL,
				DAT_IDENTITY,
				MSG_GETDEFAULT,
				(TW_MEMREF)&tdsid);
	if(twRC!=TWRC_SUCCESS) return false;

	twRC = TWRC_FAILURE;
	if (name) {
		strcpy(dsID.ProductName,name);
		dsID.Id=0;
	} else {
		twRC = lpDSM_Entry(&appID,
						NULL,
						DG_CONTROL,
						DAT_IDENTITY,
						MSG_USERSELECT,
						(TW_MEMREF)&tdsid);
		if(twRC!=TWRC_SUCCESS) return false;
		dsID = tdsid; 
	}
/*
	if (name) {
		strcpy(tdsid.ProductName,"");
		tdsid.Id=0;
		twRC = lpDSM_Entry(&appID,
						NULL,
						DG_CONTROL,
						DAT_IDENTITY,
						MSG_OPENDS,
						(TW_MEMREF)&tdsid);
		twRC = lpDSM_Entry(&appID,
						NULL,
						DG_CONTROL,
						DAT_IDENTITY,
						MSG_CLOSEDS,
						(TW_MEMREF)&tdsid);
	if(twRC!=TWRC_SUCCESS){
		twRC = lpDSM_Entry(&appID,
						NULL,
						DG_CONTROL,
						DAT_IDENTITY,
						MSG_USERSELECT,
						(TW_MEMREF)&tdsid);
	}
	if(twRC!=TWRC_SUCCESS) return false;
	dsID = tdsid; 
*/
	//MessageBox(hw,tdsid.ProductName,"KV",MB_OK);
	return true;
}


void twain_getimage(){
	TW_INT16 rc;
	TW_UINT32 hBitmap=NULL;
	TW_BOOL PendingXfers = TRUE;
	LPBITMAPINFOHEADER	lpDib;

	rc = lpDSM_Entry(&appID,&dsID,DG_IMAGE,DAT_IMAGENATIVEXFER,MSG_GET,(TW_MEMREF)&hBitmap);
	lpDib = (LPBITMAPINFOHEADER)GlobalLock((void*)hBitmap);

	// ߒl̃`FbN
	switch(rc){
		case TWRC_XFERDONE:
			if(lpDib!=NULL){
				// 
				//MessageBox(hWnd,"OK","TWAIN(K-View)",MB_OK);

				// BITMAP쐬
				LPBITMAPINFO bi = (LPBITMAPINFO)lpDib;
				LPBYTE img = (LPBYTE)lpDib + lpDib->biSize;
				if(lpDib->biBitCount<=8){
					img+=(1<<lpDib->biBitCount)*4;
				}
				bms->Delete();
				bms->Create(lpDib->biWidth,lpDib->biHeight,0);
				HBITMAP hBmp = CreateDIBitmap(bms->hdc,lpDib,CBM_INIT,img,bi,DIB_RGB_COLORS);
				//if(!hBmp)return false;
				HDC mDC= CreateCompatibleDC(bms->hdc);
				SelectObject(mDC,hBmp);
				BitBlt(bms->hdc,0,0,lpDib->biWidth,lpDib->biHeight,mDC,0,0,SRCCOPY);
				//memcpy(bms->pBit,lpDib,lpDib->biWidth*3*lpDib->biHeight);
				DeleteDC(mDC);
				DeleteObject(hBmp);
			}
			break;
		case TWRC_CANCEL:
			// LZ
			MessageBox(hWnd,"LZ܂","TWAIN(K-View)",MB_OK);
		break;

		case TWRC_FAILURE:
			// G[
			MessageBox(hWnd,"]G[","TWAIN(K-View)",MB_OK);
		break;
	}
	if(lpDib!=NULL){
		GlobalUnlock((void*)hBitmap);
		GlobalFree((void*)hBitmap);
	}
	mode=3;
}

void twain_close(){
	//fBZ[u
	mode=3;
	TW_INT16 rc;
	//ui.ShowUI=FALSE;
	//ui.ModalUI=FALSE;
	//ui.hParent=hWnd;
	rc=lpDSM_Entry(&appID,&dsID,DG_CONTROL,DAT_USERINTERFACE,MSG_DISABLEDS,&ui);


	//\[XN[Y
	rc=lpDSM_Entry(&appID,NULL,DG_CONTROL,DAT_IDENTITY,MSG_CLOSEDS,&dsID);
	twain_free();
}

bool twain_get(HWND hWnd,CBitmap *bm,int flag,UINT lprm){
	lparam=lprm;
	bms=bm;
	if(mode==1)
		twain_init(hWnd);

	TW_UINT16 rc;				// ߒl

	//\[XI[v
	rc=lpDSM_Entry(&appID,NULL,DG_CONTROL,DAT_IDENTITY,MSG_OPENDS,&dsID);
	if(rc != TWRC_SUCCESS)
		return FALSE;
	//MessageBox(hWnd,dsID.ProductName,"debug",MB_OK);

	//Cl[u
	ui.ShowUI=flag&1;
	ui.ModalUI=flag&1;
	ui.hParent=hWnd; //eEBhEiShowUI=TRUE͕̎K{j
	rc=lpDSM_Entry(&appID,&dsID,DG_CONTROL,DAT_USERINTERFACE,MSG_ENABLEDS,&ui);
	if(rc != TWRC_SUCCESS){
		//G[
	}
	mode=5;

//	twain_getimage();
//	twain_close();
	return false;

}

int twain_msg(LPMSG msg){
	TW_UINT16  twRC = TWRC_NOTDSEVENT;
	TW_EVENT   twEvent;

	if(mode<4)
		return 0;

	memset(&twEvent, 0, sizeof(TW_EVENT));
	twEvent.pEvent = (TW_MEMREF)msg;
	twRC = lpDSM_Entry(&appID,
				&dsID, 
				DG_CONTROL, 
				DAT_EVENT,
					MSG_PROCESSEVENT, 
				(TW_MEMREF)&twEvent);

	switch (twEvent.TWMessage){
		case MSG_XFERREADY:
			// fB(mode:6)
			twain_getimage();
			twain_close();
			PostMessage(hWnd,WM_COMMAND,TWAIN_SUCCESS,lparam);
			break;
		case MSG_CLOSEDSREQ:
			// fBZ[uN[Yv
			twain_close();
			break;
		case MSG_NULL:
			// bZ[WȂ
			break;
	}
	return (twRC==TWRC_DSEVENT);
}
